<?php
require_once('lib/mail.inc'); 
require_once('lib/mailView.inc'); 
require_once('lib/mailSend.inc'); 
define('LINE_MAX', 76); 
define('MAIN_CONTENT_SELECTOR', 'messageContent'); 
define('SPELLCHECKER_MAX_WORD_LENGTH', 35); 
define('SPELLCHECKER_MAX_SUGGESTIONS_NUMBER', 30); 
define('SPELLCHECKER_MAX_BUFFER_TO_PARSE', 5000); 
define('SPELLCHECKER_JS_LONGWORD', '--LONGWORD--'); 
define('SPELLCHECKER_JS_NOMORESUGG', '--NOMORE--'); 
$eps = array( 
KMS_FMAIL => 'eml', 
KMS_FCONTACT => 'vcf', 
KMS_FCALENDAR => 'ics', 
KMS_FTODO => 'ics', 
KMS_FNOTE => 'txt' 
); 
function eh0($uc, $atn, $dmm) { 
global $l; 
$ept = $l->createSpellChecker($uc); 
echo '/*'; 
$atn = preg_replace("/<\?xml[^>]*>/si", '', $atn); 
if ('plain' == $dmm) { 
$atn = aiz($atn); 
} 
$epu = true; 
$epv = substr($uc, 0, 2); 
if (mb_strlen($atn) <= SPELLCHECKER_MAX_BUFFER_TO_PARSE) { 
$crk = kerio_words($epv, $atn, $epu); 
} 
else { 
$epw = mb_substr($atn, 0, SPELLCHECKER_MAX_BUFFER_TO_PARSE); 
$epx = $atn; 
$crk = array(); 
$epy = 0; 
$cgu = 0; 
while ('' != $epw) { 
echo '.'; 
flush(); 
$epz = mb_strlen($epw); 
for ($bi = 0; $bi < 256; $bi++) { 
$eq0 = mb_substr($epx, $epz + $bi, 1); 
if ('<' == $eq0 || '>' == $eq0 || ' ' == $eq0 || '' == $eq0) { 
$epw .= mb_substr($epx, $epz, $bi); 
break; 
} 
} 
$dto = kerio_words($epv, $epw, $epu); 
foreach ($dto as $eqa => $crf) { 
$crk[$eqa + $cgu] = $dto[$eqa]; 
} 
$epy = $eqa; 
if (0 == $epy) { 
$epw = mb_substr($epx, 0, mb_strlen($epw) + SPELLCHECKER_MAX_BUFFER_TO_PARSE); 
if ($epw == $epx) { 
break; 
} 
else { 
continue; 
} 
} 
$cgu += $epy; 
$axt = mb_substr($epx, mb_strlen($epw)); 
if ('' != $axt) { 
array_pop($crk); 
$epx = mb_substr($epx, $epy); 
$epw = mb_substr($epx, 0, SPELLCHECKER_MAX_BUFFER_TO_PARSE); 
} 
else { 
$epw = ''; 
} 
} 
} 
$eqb = array(); 
$eqc = array(); 
$eqd = 0; 
foreach ($crk as $eqa => $crf) { 
if (!$ept->check($crf["word"])) { 
$eqe = $crf['word']; 
$crf['position'] = $eqa; 
if (mb_strlen($eqe) > SPELLCHECKER_MAX_WORD_LENGTH) { 
$crf['suggestions'] = array(SPELLCHECKER_JS_LONGWORD); 
} 
else if (isset($eqc[$eqe])) { 
$crf['suggestions'] = $eqc[$eqe]; 
} 
else if ($eqd >= SPELLCHECKER_MAX_SUGGESTIONS_NUMBER) { 
$crf['suggestions'] = array(SPELLCHECKER_JS_NOMORESUGG); 
} 
else { 
$eqd++; 
$crf['suggestions'] = $ept->suggest($eqe); 
$eqc[$eqe] = $crf['suggestions']; 
} 
echo '.'; 
flush(); 
array_push($eqb, $crf); 
} 
} 
$eaz = count($eqb); 
for ($bi = count($eqb)-1; $bi >= 0; $bi--) { 
$eqf = $eqb[$bi]; 
$atn = mb_substr($atn, 0, $eqf['position']) 
. '<span class="hit" id="keriow' . $eaz-- . '" s="' . aiz(implode('|', $eqf['suggestions'])) . '">' 
. $eqf['word'] . '</span>' . $eqf['tags'] 
. mb_substr($atn, $eqf['position']+$eqf['length']); 
echo '.'; 
flush(); 
} 
echo '*/'; 
if (count($eqb) == 0) { 
echo "alert('" . ajw('mail-spellchecker-nomistake') . "');\n"; 
echo "setTimeout('window.top.close();', 1);\n"; 
} else { 
echo "api.eqg = " . count($eqb) . ";\n"; 
echo "api.cbn = \"" . arj($atn, 0, false) . "\";\n"; 
echo "api.eqh();\n"; 
} 
} 
function dwr($ale, $dak) { 
global $ti,$o; 
$aki = eqi($ale); 
$eqj = chy(cgt($ale->getDeliveryTime())); 
$eqk = eql($ale); 
$eqm = $dak->getSubject(); 
$apt = axv($dak->getFromAddress()); 
switch ($aki) { 
case KMS_FMAIL: 
$apu = trim($dak->getNewsgroups()); 
if (!$apu) { 
$apu = axv($dak->getToAddresses()); 
} 
$eqn = axv($dak->getCcAddresses()); 
$eqo = $dak->getDate(); 
$eqo = ($eqo > 0 ? chy(cgt($eqo)) : ""); 
break; 
case KMS_FCALENDAR: 
$bsh = $ale->getBody(); 
$bcf = $bsh->getContents(); 
$agw = $bcf->toCalendarEvent(); 
if (!is_null($agw)){ 
if (!$eqm) $eqm = $agw->getSummary(); 
if (!$apt) { 
$eqp = $agw->getOrganizer(); 
$apt = $eqp["name"]; 
if ('' == $apt) { 
$apt = $eqp["address"]; 
} 
} 
} 
break; 
case KMS_FTODO: 
$bsh = $ale->getBody(); 
$bcf = $bsh->getContents(); 
$agw = $bcf->toCalendarTodo(); 
if (!is_null($agw)){ 
if (!$eqm) $eqm = $agw->getSummary(); 
if (!$apt) { 
$eqp = $agw->getOrganizer(); 
$apt = $eqp["name"]; 
if ('' == $apt) { 
$apt = $eqp["address"]; 
} 
} 
} 
break; 
case KMS_FCONTACT: 
$bsh = $ale->getBody(); 
$bcf = $bsh->getContents(); 
$crn = $bcf->toContact(); 
if (!is_null($crn)){ 
if (!$eqm) $eqm = $crn->getCommonName(); 
if (!$apt) $apt = $o->getUserName(); 
$eqq = $crn->isDList() ? CONTACT_TYPE_DLIST : CONTACT_TYPE_CONTACT; 
} 
break; 
case KMS_FNOTE: 
$bsh = $ale->getBody(); 
$bcf = $bsh->getContents(); 
$eqr = $bcf->toStickyNote(); 
if (!is_null($eqr)) { 
$eqq = $eqr->getColor(); 
} 
break; 
} 
if ($aki == KMS_FMAIL) { 
$ajn = $ale->getMapiClass(); 
if (strstr($ajn, "IPM.Schedule.Meeting")) 
$aki = KMS_FCALENDAR; 
if (strstr($ajn, "IPM.TaskRequest")) 
$aki = KMS_FTODO; 
} 
$ak = ''; 
$ak .= apk($dak->getPriority()) . ","; 
$ak .= apk($dak->hasAttachments()) . ","; 
$ak .= apk($eqk) . ","; 
$ak .= apk(aiz($apt)) . ","; 
$ak .= apk(aiz(aj0($eqm, 1000))) . ","; 
$ak .= apk($eqj) . ","; 
$ak .= apk($eqo) . ","; 
$ak .= apk(chq($ale->getSize())) . ","; 
$ak .= apk(aiz(aj0($apu, 1000))) . ","; 
$ak .= apk(aiz(aj0($eqn, 1000))) . ","; 
$ak .= apk($aki); 
if (isset($eqq)) { 
$ak .= "," . apk($eqq); 
} 
return $ak; 
} 
function efk($aos, $ahd, $eqs, $eqt, $ctt, $ctu) 
{ 
global $aa, $equ; 
$alc = ald($aos, KMS_FMAIL); 
$ale = alf($alc, KMS_FMAIL); 
$ale->gotoUid($ahd); 
if ($ale->isValid() == false) { 
ala('E_MESSAGE_BADUID',$aos); 
aox('getMessageContent','E_MESSAGE_BADUID', "folder: " . $aos . "; uid: " . base_convert($ahd, 10, 16)); 
} 
if ($_POST['desktop'] == 'mailView.php') { 
$awz = dvl($alc, KMS_FMAIL, $ctt, $ctu); 
$ale->setSubset($awz); 
$ale->gotoUid($ahd); 
$eqv = ($ale->gotoPrev() ? $ale->getUid() : -1); 
$ale->gotoUid($ahd); 
$ali = ($ale->gotoNext() ? $ale->getUid() : -1); 
$ale->gotoUid($ahd); 
echo "api.cnf = " . $ahd . ";\n"; 
echo "api.eqw = " . $eqv . ";\n"; 
echo "api.eqx = " . $ali . ";\n"; 
} 
unset($alc); 
$bsh = $ale->getBody(); 
if ($bsh->findContentType("application", "ms-tnef")) { 
$ale->convertFromTnef(); 
$bsh = $ale->getBody(); 
} 
if ($bsh->hasUuencodedPart()) { 
$ale->convertUuencodedAttachment(); 
$bsh = $ale->getBody(); 
} 
$bcf = $bsh->getContents(); 
$dak = $ale->getEnvelope(); 
if ($eqt != "") { 
$bcf = eqy($bcf, $eqt); 
$bcf = $bcf->toMessageBody(); 
$dak = $bcf; 
$bcf = $bcf->getContents(); 
$eqt .= ".0"; 
} else $eqt = 0; 
$apu = trim($dak->getNewsgroups()); 
if (!$apu) { 
$apu = axv($dak->getToAddresses(), 'full_preview'); 
} 
$eqn = axv($dak->getCcAddresses(), 'full_preview'); 
$eqz = axv($dak->getBccAddresses(), 'full_preview'); 
$er0 = $dak->getSubject(); 
$era = 'false'; 
if (!$er0) { 
$aki = eqi($ale); 
switch ($aki) { 
case KMS_FCALENDAR: 
$agw = $bcf->toCalendarEvent(); 
if (!is_null($agw)) $er0 = $agw->getSummary(); 
break; 
case KMS_FTODO: 
$agw = $bcf->toCalendarTodo(); 
if (!is_null($agw)) $er0 = $agw->getSummary(); 
$era = 'true'; 
break; 
case KMS_FCONTACT: 
$agw = $bcf->toContact(); 
if (!is_null($agw)) $er0 = $agw->getCommonName(); 
break; 
} 
} else { 
$ajn = $ale->getMapiClass(); 
if (strstr($ajn, 'IPM.TaskRequest')) { 
$era = 'true'; 
} 
} 
$ahv = $dak->getDate(); 
if ($ahv > 0) $ahv = chy(cgt($ahv), "full"); 
echo "api.erb();\n"; 
echo "api.erc("; 
echo apk(aiz(axv($dak->getFromAddress(), 'full_preview'))), ","; 
echo apk(aiz(aj0($er0, 1000))), ","; 
echo apk($ahv), ","; 
echo apk(aiz(aj0($apu, 1000))). ","; 
echo apk(aiz(aj0($eqn, 1000))). ","; 
echo apk(aiz(aj0($eqz, 1000))); 
echo ");\n"; 
if ($_POST['desktop'] == 'mailView.php') { 
$er0 = aj0($er0, 64); 
$er0 = strtr($er0, "\r\n", "  "); 
$er0 = addslashes($er0); 
$er0 = "'" . str_replace('<', "<'+'", $er0) . "'"; 
echo "parent.document.title = " . $er0 . ";\n"; 
} 
$equ = array( 
'folder' => $aos, 
'uid' => $ale->getUid(), 
'from' => $dak->getFromAddress(), 
'cidsShownInline' => array() 
); 
$bl = new bm(); 
$erd = ($bl->aoo() == '6'); 
ere($bcf, $eqt, $erd); 
echo "api.erf($era);\n"; 
$erg = $ale->getFlags(); 
unset($ale, $bsh, $bcf); 
if ($eqt != 0) { 
unset($dak); 
} 
if ($aa['mailMarkAsRead'] || $_POST['desktop'] == 'mailView.php') 
ega($aos, $ahd, "read"); 
if ($eqs == "print") { 
echo "api.erh();\n"; 
} 
if ($eqs == "flag" || $eqs == "unflag") { 
ega($aos, $ahd, $eqs); 
} 
if ($_POST['desktop'] == 'mailView.php') { 
echo "api.eri(true);\n"; 
} 
$dxe = substr(strstr($aos, "/"), 1); 
if ($eqt == 0 && $aa['mailReceiptResponse'] != 0 && $dxe != FLD_SENT && $dxe != FLD_DRAFT) { 
$erj = $dak->getDispositionNotificationTo(); 
if ($erj != "") { 
if (!in_array(KMS_MMDNSENT, $erg)) 
if ($aa['mailReceiptResponse'] == MDN_ALWAYS) { 
ege($aos, $ahd, true); 
} elseif($aa['mailReceiptResponse'] == MDN_MANUAL) { 
echo "if (api.confirm(\"".ajw('mail-receipt-confirm')."\"))" 
. "	api.erk(".apk($aos).",".$ahd.");\n"; 
} 
ega($aos, $ahd, "receiptsent"); 
} 
} 
} 
function ere($bsh, $eqt, $erd = false) 
{ 
global $equ; 
global $cgn; 
global $eps; 
static $erl = false; 
static $erm = false; 
static $ern = 0; 
if ($ern++ > BODY_PART_MAX_CALL) return false; 
if (substr_count($eqt, '.') > BODY_PART_MAX_DEPTH) return false; 
if (is_null($bsh)) return false; 
$ero = strtolower($bsh->getContentId()); 
if (is_array($equ['cidsShownInline'])) { 
if (in_array($ero, $equ['cidsShownInline']) || in_array('<' . $ero . '>', $equ['cidsShownInline'])) { 
return false; 
} 
} 
$erp = strtolower($bsh->getContentType()); 
$erq = strtolower($bsh->getContentSubType()); 
$err = $erp . "/" . $erq; 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) $ert[strtolower($axu['name'])] = strtolower($axu['value']); 
$eru = strtolower($bsh->getContentTransferEncoding()); 
$erv = chq(erw($bsh)); 
$erx = ery($bsh); 
if ($erx == "winmail.dat" || $erx == "smime.p7s") return false; 
$erz = es0($bsh); 
$esa = 'mailAttach/'; 
$esb = esc($erx); 
$esd = '?part=' . $eqt . '&folder=' . urlencode($equ['folder']) . '&uid=' . $equ['uid']; 
$ese = $esa . $esb . $esd; 
$dxh = "fileg"; 
$esf = "attachment"; 
if ($err == "application/pdf") 
$esf = "inline"; 
if ($erl) $esg = "api.esh(\"<hr size='1'/>\");\n"; 
switch ($erp) { 
case "text": 
switch ($erz) { 
case KMS_FCALENDAR: 
case KMS_FTODO: 
$esi = $ert['method']; 
$esj = ($erz == KMS_FCALENDAR); 
$dxh = ($esj ? "fcalendarg" : "ftodog"); 
$adg = ($esj ? $bsh->toCalendarEvent() : $bsh->toCalendarTodo()); 
if (!is_null($adg)) { 
$any = $adg->getSummary(); 
if (!$esi) 
$esi = esk($adg->getMethod()); 
} 
if (($equ['folder'] == $GLOBALS['aqj']."/".FLD_TRASH) 
|| ($equ['folder'] == $GLOBALS['aqj']."/".FLD_SENT)) { 
$esl = true; 
} 
if (($esi == 'request' || $esi == 'reply' || $esi == 'cancel') && !$esl) { 
if (!$erm) { 
esm($bsh, $eqt); 
$erm = true; 
$erl = true; 
} 
return false; 
} 
$esn = $any; 
break; 
case KMS_FCONTACT: 
$dxh = "fcontactg"; 
$crn = $bsh->toContact(); 
if (!is_null($crn)) { 
$esn = $crn->getCommonName(); 
if ($crn->isDList()) { 
$cso = true; 
$dxh = 'dlist'; 
} 
} 
break; 
case KMS_FNOTE: 
$eqr = $bsh->toStickyNote(); 
if (!is_null($eqr)) { 
$esn = $eqr->getSubject(); 
$aix = $eqr->getColor(); 
} else { 
$aix = DEFAULT_NOTE_COLOR; 
} 
$dxh = 'note' . $cgn[$aix]['iconColor']; 
break; 
default: 
switch ($erq) { 
case "plain": 
case "enriched": 
case "html": 
echo $esg; 
$eso = esp($bsh, $eqt); 
if ($eso) $erl = true; 
$esf = "inline"; 
break; 
case "rfc822-headers": 
$chg = $bsh->toMessageBody(); 
if ($chg){ 
$apt = axv($chg->getFromAddress(), 'full_preview'); 
$apu = axv($chg->getToAddresses(), 'full_preview'); 
$ahv = $chg->getDate(); 
echo $esg; 
echo "api.esh(\""; 
$aqo = "<div style='background-color: #EEEEEE; padding: 4px'>"; 
if ($apt) $aqo.= "<b><kerio:text id='msg-table-mail-from'/>:</b> " . aiz($apt) . "&nbsp;"; 
if ($apu) $aqo.= "<b><kerio:text id='msg-table-mail-to'/>:</b> " . aiz($apu) . "<br>"; 
$aqo.= "<b><kerio:text id='msg-table-mail-subject'/>:</b> " . aiz($chg->getSubject()) . "<br>"; 
if ($ahv) $aqo.= "<b><kerio:text id='msg-table-mail-date'/>:</b> " 
. chy(cgt($ahv), "full"); 
echo $aqo . "</div><p>"; 
echo "\");\n"; 
$bcf = $chg->getContents(); 
$erl = false; 
ere($bcf, $eqt.".0", $erd); 
$erl = true; 
} 
break; 
} 
} 
break; 
case "image": 
$dxh = "imageg"; 
if (in_array($erq, explode(" ", "gif jp2 jpeg jpg pjpeg png x-png"))) { 
echo $esg; 
echo "api.esh(\""; 
$esq = $GLOBALS['aa']['mailImgInline']; 
if (!isset($esq) || $esq == 1) { 
echo "<img src='$ese' class='inline-attachment' defaultContextMenu='yes' alt='".aiz($erx)."'>"; 
} else { 
echo "<img src='gfx/image.gif' class='icon'> " 
. "<a href='$ese' target='_blank' defaultContextMenu='yes'><kerio:text id='mail-view-image'/></a>"; 
} 
echo "\");\n"; 
$esf = "inline"; 
$erl = true; 
} 
break; 
case "message": 
$dxh = "mcomposeg"; 
if ($erq == "rfc822") { 
$chg = $bsh->toMessageBody(); 
if ($chg == NULL) return false; 
$apt = axv($chg->getFromAddress(), 'full_preview'); 
$apu = axv($chg->getToAddresses(), 'full_preview'); 
$er0 = $chg->getSubject(); 
$ahv = $chg->getDate(); 
$esn = $er0; 
echo $esg; 
echo "api.esh(\""; 
$aqo = "<div style='background-color: #EEEEEE; padding: 4px'>"; 
if ($apt) $aqo.= "<b><kerio:text id='msg-table-mail-from'/>:</b> " . aiz($apt) . "&nbsp;"; 
if ($apu) $aqo.= "<b><kerio:text id='msg-table-mail-to'/>:</b> " . aiz($apu) . "<br>"; 
$aqo.= "<b><kerio:text id='msg-table-mail-subject'/>:</b> " . aiz($er0) . "<br>"; 
if ($ahv) $aqo.= "<b><kerio:text id='msg-table-mail-date'/>:</b> " 
. chy(cgt($ahv), "full"); 
echo $aqo . "</div><p>"; 
echo "\");\n"; 
$bcf = $chg->getContents(); 
$erl = false; 
ere($bcf, $eqt.".0", $erd); 
$erl = true; 
} 
break; 
case "multipart": 
if ($bsh->isContentType("multipart", "alternative")) { 
$esr = $bsh->toMultipartBody(); 
$ess = $esr->getCount(); 
$est = array(); 
for ($esu = 0; $esu < $ess; $esu++) { 
$esv = $esr->getBodyPart($esu); 
$aki = strtolower($esv->getContentType())."/".strtolower($esv->getContentSubType()); 
if ($aki == "multipart/related" || $aki == "multipart/mixed") { 
$esw = $esv->toMultipartBody(); 
$esx = $esw->getCount(); 
for ($esy = 0; $esy < $esx; $esy++) { 
$esz = $esw->getBodyPart($esy); 
if ($aki == "multipart/related" && $esz->isContentType("text", "html")) { 
$aki = "multipart/related/html"; 
} 
elseif ($aki == "multipart/mixed" && $esz->isContentType("text", "*")) { 
$aki = "multipart/mixed/text"; 
} 
} 
} 
$est[$eqt.".".$esu] = $aki; 
} 
$et0 = array_search("text/x-stickynote", $est); 
if (!$et0) 
$et0 = array_search("text/x-vcard-dl", $est); 
if (!$et0) 
$et0 = array_search("text/calendar", $est); 
if (!$et0) 
$et0 = array_search("text/html", $est); 
if (!$et0) 
$et0 = array_search("multipart/related/html", $est); 
if (!$et0) 
$et0 = array_search("multipart/mixed/text", $est); 
if (!$et0) 
$et0 = array_search("text/plain", $est); 
if (count($est) == 1) { 
$et0 = key($est); 
} 
for ($esu = 0; $esu < $ess; $esu++) { 
$eta = $eqt.".".$esu; 
if ($eta == $et0) { 
$esv = $esr->getBodyPart($esu); 
ere($esv, $eta, $erd); 
} 
} 
} else { 
$esr = $bsh->toMultipartBody(); 
$ess = $esr->getCount(); 
for ($esu = 0; $esu < $ess; $esu++) { 
$esv = $esr->getBodyPart($esu); 
ere($esv, $eqt.".".$esu, $erd); 
} 
} 
break; 
case "application": 
if (in_array($erq, explode(" ", "x-pkcs7-mime pkcs7-mime pkcs10"))) { 
echo $esg; 
echo "api.esh(\""; 
echo "<kerio:text id='mail-encrypted1'/><br><br><kerio:text id='mail-encrypted2'/>"; 
echo "\");\n"; 
$erl = true; 
} 
break; 
} 
if ((($erx !== false) || isset($esn)) && $err != "application/applefile") 
{ 
if (isset($esn)) { 
$esd .= "&disp=attachment"; 
$ese = $esa . $esb . $esd; 
if ($erx == false) { 
$erx = aj0($esn, 64, '') . '.' . $eps[$erz]; 
$esb = esc($erx); 
$ese = $esa . $esb . $esd; 
} 
if ($erz == KMS_FMAIL) { 
$etb = '.' . $eps[KMS_FMAIL]; 
if (strtolower(strrchr($erx, '.')) != $etb) { 
$erx .= $etb; 
$esb = esc($erx); 
$ese = $esa . $esb . $esd; 
} 
} 
$etc = "contextMenu='attachment'"; 
$etd = "href=''"; 
if ($erz == KMS_FCONTACT) { 
$ete = $cso ? CONTACT_TYPE_DLIST : CONTACT_TYPE_CONTACT; 
$etd .= " attSubType='" . $ete . "'"; 
$etf = ',\"' . $ete . '\"'; 
} 
$etd .= " onclick='etg(\\\"$eqt\\\",\\\"$erz\\\"$etf);return false'" 
. " attType='" . $erz . "' attPart='" . $eqt . "' attUri='" . $ese . "'"; 
if ($esn != '') { 
$eth = $esn; 
} 
else { 
$eti = strrpos($erx, '.'); 
$eth = ($eti !== false ? substr($erx, 0, $eti) : $erx); 
} 
} elseif ($err == 'text/html') { 
$etj = $esa . $esb . $esd . "&disp=inline"; 
$etk = $esa . $esb . $esd . "&disp=attachment"; 
$etd = "href='" . $etj . "' target='_blank'" 
. " attUriOpen='" . $etj . "' attUri='" . $etk . "'"; 
$etc = "contextMenu='attachment'"; 
$eth = $erx; 
} else { 
$esd .= "&disp=" . $esf; 
$ese = $esa . $esb . $esd; 
$etc = "defaultContextMenu='yes'"; 
$etl = strrchr($erx, '.'); 
if (strcasecmp($etl, '.exe') == 0 || strcasecmp($etl, '.dll') == 0) { 
$ese .= '&ext=' . $etl; 
} 
$etd = "href='" . $ese ."'"; 
if ('inline' == $esf || $erd) { 
$etd .= " target='_blank' "; 
} 
$eth = $erx; 
} 
echo "api.etm(\""; 
echo "<a $etd $etc>"; 
echo "<img src='gfx/".$dxh.".gif' height='16' align='top' " . $etc . ">"; 
echo "<span>"; 
echo aiz(arj(aj0($eth, 64)))."</span></a> ($erv)"; 
echo "\");\n"; 
} 
} 
function es0($etn) 
{ 
$erp = $etn->getContentType(); 
$erq = $etn->getContentSubType(); 
$ers = $etn->getContentTypeAttributes(); 
foreach ($ers as $axu) { 
if (strtolower($axu['name']) == 'component') { 
$duh = $axu['value']; 
break; 
} 
} 
switch (strtolower($erp . '/' . $erq . '/' . $duh)) { 
case "text/directory/": 
case "text/x-vcard/": 
case "text/x-vcard-dl/": 
case "text/vcard/": 
$eto = KMS_FCONTACT; 
break; 
case "text/calendar/": 
case "text/calendar/vevent": 
$eto = KMS_FCALENDAR; 
break; 
case "text/calendar/vtodo": 
$eto = KMS_FTODO; 
break; 
case "text/x-stickynote/": 
$eto = KMS_FNOTE; 
break; 
default: 
$eto = KMS_FMAIL; 
} 
return $eto; 
} 
function esp($bsh, $eqt) 
{ 
global $aa; 
$erp = strtolower($bsh->getContentType()) . "/" . strtolower($bsh->getContentSubType()); 
$epw = etp($bsh, false); 
if (strlen(trim($epw)) == 0) return false; 
$etq = ($erp == "text/html" ? etr($epw) : ""); 
if ($etq != 'utf-16') { 
$ets = ""; 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) { 
if (strtolower($axu['name']) == 'charset') { 
$ets = strtolower($axu['value']); 
break; 
} 
} 
$ett = $ets; 
$etu = false; 
if ($etq != "" && $etq != $ets) { 
$etv = kerio_convert($etq, "utf-8", $epw); 
if (kerio_convert("utf-8", $etq, $etv) == $epw) { 
$etu = true; 
$epw = $etv; 
} 
} 
if (!$etu) { 
if ($ett == '') { 
$ett = 'utf-8'; 
} 
$epw = Kerio_convert($ett, "utf-8", $epw); 
} 
} 
$epw = etw($epw, $erp, MODE_DISPLAY_FULL, $eqt, $aa['mailImgAllowRemote']); 
if ($bsh->isContentType("text","html")) { 
$epw = arj($epw, 0, false); 
} elseif ($bsh->isContentType("text","plain")) { 
$epw = arj($epw, 0, false); 
} else { 
$epw = arj($epw, 1, false); 
} 
echo "api.esh(\""; 
echo $epw; 
echo "\");\n"; 
return true; 
} 
function etp($bsh, $etx = true) { 
$ety = strtolower($bsh->getContentType()); 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) { 
if (strtolower($axu['name']) == 'charset') $ett = strtolower($axu['value']); 
} 
$epw = ""; 
$alh = $bsh->openDecodedContentsStream(); 
while (!feof($alh)) { 
$epw .= fread($alh, 81920); 
} 
fclose($alh); 
if ($etx && $ety == "text" && $ett && strtolower($ett) != "utf-8") { 
$epw = Kerio_convert($ett, "utf-8", $epw); 
} 
return $epw; 
} 
function erw($bsh) 
{ 
$etz = strtolower($bsh->getContentTransferEncoding()); 
$bdz = $bsh->getContentLength(); 
if ($etz == 'base64') { 
$bdz = $bdz / 1.33; 
} 
return $bdz; 
} 
function eu0($bsh, $eqt = 0) 
{ 
static $ern = 0; 
if ($ern++ > BODY_PART_MAX_CALL) return array(); 
if (substr_count($eqt, '.') > BODY_PART_MAX_DEPTH) return array(); 
$eua = array(); 
$erj = $bsh->getContentDisposition(); 
$erp = strtolower($bsh->getContentType()); 
$err = $erp . "/" . strtolower($bsh->getContentSubType()); 
if ($err == "multipart/mixed" 
|| $err == "multipart/related" 
|| $err == "multipart/parallel" 
|| $err == "multipart/signed" 
|| $err == "multipart/alternative" 
|| $err == "multipart/appledouble") 
{ 
$esr = $bsh->toMultipartBody(); 
$ess = $esr->getCount(); 
for ($esu = 0; $esu < $ess; $esu++) { 
$esv = $esr->getBodyPart($esu); 
$eub = $eqt.".".$esu; 
$eqp = eu0($esv, $eub); 
$eua = array_merge($eua, $eqp); 
} 
} elseif( ($erp != "text" || $erj == "attachment" || $erj == "inline") 
&& $erp != "multipart" 
&& $err != "application/applefile") 
{ 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) 
if (strtolower($axu['name']) == 'component') $duh = strtolower($axu['value']); 
$eqp['type'] = strtolower($bsh->getContentType()."/".$bsh->getContentSubType()); 
if ($duh) 
$eqp['component'] = $duh; 
$eqp['size'] = erw($bsh); 
$eqp['name'] = ery($bsh); 
if (!$eqp['name']) 
$eqp['name'] = strtolower($bsh->getContentType()); 
$eqp['part'] = $eqt; 
return (array($eqp)); 
} 
return $eua; 
} 
function aup($axu, $c0y = 'angle') 
{ 
if ($axu['name'] == $axu['address']) 
return $axu['address']; 
$fb = cwm($axu['name']); 
if (strlen($fb) > 0) { 
switch($c0y) { 
case 'square': $crt = ' [mailto:'.$axu['address'].']'; break; 
case 'angle': 
default: $crt = ' <'.$axu['address'].'>'; break; 
} 
} else { 
$crt = $axu['address']; 
} 
return $fb.$crt; 
} 
function euc($dak, $c0y = 'text') 
{ 
$apu = $dak->getToAddresses(); 
foreach ($apu as $crt) { 
if ($dju) $dju.= ", "; 
$dju.= aup($crt); 
} 
$ahv = $dak->getDate(); 
$ahv = ($ahv > 0 ? ajm("%kdate %ktime", cgt($ahv)) : ""); 
$cae = array( 
array(ajw('mail-to'), $dju), 
array(ajw('mail-subject'), $dak->getSubject()), 
array(ajw('mail-receipt-mail-date'), $ahv) 
); 
$eud = stripslashes(ajw('mail-receipt-mail-text1')); 
$eue = stripslashes(ajw('mail-receipt-mail-text2')) . " " 
. ajm("%kdate %ktime", cgt(mktime())); 
switch ($c0y) { 
case "html": 
$aqo = "<p style='font: 12px Verdana, Arial, sans-serif'>".$eud."</p>\n"; 
$aqo.= "<table style='font: 12px Verdana, Arial, sans-serif'>\n"; 
foreach($cae as $cah) { 
if (strlen($cah[1]) > 0) { 
$aqo.= "<tr><td><b>" . $cah[0] . ":</b></td><td>" . $cah[1] . "</td></tr>\n"; 
} 
} 
$aqo.= "</table>\n\n<p style='font: 12px Verdana, Arial, sans-serif'>".$eue."</p>\n"; 
break; 
case "text": 
default: 
$aqo = $eud."\n\n"; 
foreach($cae as $cah) { 
if (strlen($cah[1]) > 0) { 
$aqo.= $cah[0] . ": " . $cah[1] . "\n"; 
} 
} 
$aqo.= "\n".$eue."\n"; 
} 
return $aqo; 
} 
function ege($aos, $ahd, $euf = false) 
{ 
global $l, $o; 
$dak = dal($aos, KMS_FMAIL, $ahd); 
$apt = aup(array("name"=>$o->getFullName(), "address"=>$o->getUserName())); 
$apu = $dak->getDispositionNotificationTo(); 
$er0 = ajw('mail-receipt-mail-subject').': '.$dak->getSubject(); 
$eug['From'] = kerio_encode_address_header('From', $apt); 
$eug['To'] = kerio_encode_address_header('To', $apu); 
$eug['Subject'] = kerio_encode_header('Subject', $er0); 
$euh = ""; 
$eui = euj($apu); 
$euk = $l->getServerInfo(); 
$eul = $euk->getHostName(); 
$eum = SERVER_SOFTWARE . ' WebMail'; 
$eun = $euf ? "automatic-action/MDN-sent-automatically" : "manual-action/MDN-sent-manually"; 
$euo['Reporting-UA'] = $eul."; ".$eum; 
$euo['Final-Recipient'] = "rfc822; ".$o->getUserName(); 
if ($dak->getMessageId()) { 
$euo['Original-Message-ID'] = $dak->getMessageId(); 
} 
$euo['Disposition'] = $eun."; displayed"; 
foreach ($euo as $eup => $fi) { 
$fi = wordwrap($fi, LINE_MAX, "\r\n\t"); 
$euq.= "$eup: $fi\r\n"; 
} 
$tu = array( 
array( 
'type'=>'multipart/alternative', 
'content'=>array( 
array( 
'type'=>'text/plain', 
'content'=>euc($dak, 'text') 
), 
array( 
'type'=>'text/html', 
'content'=>euc($dak, 'html') 
) 
), 
), 
array( 
'type'=>'message/disposition-notification', 
'content'=>$euq 
) 
); 
$erp = 'multipart/report'; 
$ert = array('report-type'=>'disposition-notification'); 
$eur = eus($eug, false, $tu, $erp, $ert); 
$eut = euu($eur, $euh, $eui, false); 
return $eut; 
} 
function euv($bsh, $euw, $m = 'outputBodyPart') 
{ 
static $ern = 0; 
static $eux = 0; 
static $ctz = false; 
if ($ern++ > BODY_PART_MAX_CALL) return false; 
$esr = $bsh->toMultipartBody(); 
if (is_null($esr)) 
return false; 
$ess = $esr->getCount(); 
$euw = strtolower($euw); 
for ($esu = 0; $esu < $ess; $esu++) { 
if ($ctz) { 
break; 
} 
$esv = $esr->getBodyPart($esu); 
$ero = strtolower($esv->getContentId()); 
if ($ero == '<' . $euw . '>' || $ero == $euw) { 
$ctz = true; 
switch ($m) { 
case 'outputBodyPart': 
return euy($esv); 
default: 
kerio_log(KMS_LOG_ERROR, 'webmail processBodyPartByCid: invalid action name'); 
} 
} else { 
$erp = $esv->getContentType(); 
switch ($erp) { 
case "message": 
if ($eux++ > BODY_PART_MAX_DEPTH) break; 
$chg = $esv->toMessageBody(); 
if (is_null($chg)) { 
break; 
} 
$bcf = $chg->getContents(); 
euv($bcf, $euw, $m); 
break; 
case "multipart": 
if ($eux++ > BODY_PART_MAX_DEPTH) break; 
euv($esv, $euw, $m); 
break; 
} 
} 
} 
} 
function euz(&$cry, $aki) 
{ 
$cvp = substr($cry, 0, 256); 
if ($aki == 'image/gif' && substr($cvp, 0, 5) == 'GIF89') { 
$ev0 = false; 
} else { 
$ev0 = (preg_match('/<[a-z]{1,10}.*>/Usi', $cvp) != 0); 
} 
return $ev0; 
} 
function euy($bsh) 
{ 
$erp = strtolower($bsh->getContentType()); 
$err = $erp . "/" . strtolower($bsh->getContentSubType()); 
if ($err == "text/richtext") { 
$err = "text/rtf"; 
} 
Header("Content-Type: " . $err); 
if ($_GET['pda'] != 1) { 
Header("Pragma: public"); 
} 
else { 
Header("Content-Length: " . round(erw($bsh))); 
} 
if ($_GET['disp'] != 'attachment') { 
$eva = 'inline'; 
$alh = $bsh->openDecodedContentsStream(); 
$epw = ''; 
while (!feof($alh)) { 
$epw .= fread($alh, 81920); 
} 
fclose($alh); 
if ($err == 'text/html') { 
global $equ; 
$equ['folder'] = $_GET['folder']; 
$equ['uid'] = $_GET['uid']; 
global $l; 
$o = $l->getMyUserInfo(); 
$aa = $o->getSettings(); 
$epw = etw($epw, 'text/html', MODE_ATTACHMENT, 0, $aa['mailImgAllowRemote']); 
} else { 
if (euz($epw, $err)) { 
$eva = 'attachment'; 
} 
} 
if ($eva == 'attachment') { 
Header("Cache-Control: private"); 
Header("Content-Disposition: attachment;"); 
} else { 
Header("Content-Disposition: inline;"); 
} 
print $epw; 
} 
else { 
Header("Cache-Control: private"); 
Header("Content-Disposition: attachment;"); 
$alh = $bsh->openDecodedContentsStream(); 
while (!feof($alh)) { 
print fread($alh, 81920); 
flush(); 
} 
fclose($alh); 
} 
} 
function bsi($bsh, $evb, $m = 'getBodyContent', $eqt = 0) 
{ 
static $ern = 0; 
if ($ern++ > BODY_PART_MAX_CALL) return null; 
if (substr_count($eqt, '.') > BODY_PART_MAX_DEPTH) return null; 
settype($evb, "string"); 
settype($eqt, "string"); 
if ($evb === $eqt) { 
switch ($m) { 
case 'getBodyContent': 
return etp($bsh, false); 
break; 
case 'returnBodyPart': 
return $bsh; 
break; 
case 'getCalendarFromBodyPart': 
return $bsh->toCalendarEvent(); 
break; 
case 'getContactFromBodyPart': 
return $bsh->toContact(); 
break; 
case 'outputBodyPart': 
return euy($bsh); 
break; 
case 'getTodoFromBodyPart': 
return $bsh->toCalendarTodo(); 
break; 
case 'getNoteFromBodyPart': 
return $bsh->toStickyNote(); 
break; 
} 
} 
if (substr($evb, 0, strlen($eqt)) != $eqt) { 
return NULL; 
} 
$erp = $bsh->getContentType(); 
switch (strtolower($erp)) { 
case "multipart": 
$esr = $bsh->toMultipartBody(); 
if (is_null($esr)) 
return false; 
$ess = $esr->getCount(); 
for ($esu = 0; $esu < $ess; $esu++) { 
$esv = $esr->getBodyPart($esu); 
$ug = bsi($esv, $evb, $m, $eqt.".".$esu); 
if (!is_null($ug)) return $ug; 
} 
break; 
case "message": 
$chg = $bsh->toMessageBody(); 
$esv = $chg->getContents(); 
$ug = bsi($esv, $evb, $m, $eqt.".0"); 
if (!is_null($ug)) return $ug; 
break; 
default: 
return NULL; 
} 
} 
function eqy($bsh, $eqt) 
{ 
return bsi($bsh, $eqt, 'returnBodyPart'); 
} 
function evc($evd, $bk) 
{ 
global $l; 
$xk = $l->getMyUserInfo(); 
$aos = "~" . $xk->getUserName() . "/" . $evd; 
$akw = $l->getFolderStore(); 
$alc = $akw->openMailFolder($aos); 
if (is_null($alc)) { 
$akw->createFolder($aos, KMS_FMAIL); 
$alc = $akw->openMailFolder($aos); 
if (is_null($alc)) { 
echo "<script>alert('Unable to open " . addslashes($aos) . "');</script>"; 
return false; 
} 
} 
$ape = $alc->insertMessage(); 
if (!is_null($ape)) { 
$agr = $ape->messageWrite($bk); 
} 
if (!$agr) { 
echo "<script>alert('Unable to save message to " . addslashes($aos) . "');</script>"; 
return false; 
} 
if ($evd == FLD_DRAFT) { 
$erg = array(KMS_MDRAFT); 
} 
else { 
$erg = array(KMS_MSEEN); 
} 
$agr = $ape->setFlags($erg, KMS_FLAGSADD); 
if (!$agr) echo "// Unable to setFlags()\n"; 
$agr = $ape->commit($cao); 
if (!$agr) { 
echo "<script>alert('Unable to save message to " . addslashes($aos) . "');</script>"; 
return false; 
} 
} 
function esm($bsh, $eqt) { 
global $o, $equ; 
$apt = $equ['from']; 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) { 
if (strtolower($axu['name']) == 'method') $esi = strtolower($axu['value']); 
if (strtolower($axu['name']) == 'component') $duh = strtolower($axu['value']); 
} 
$erz = ($duh == "vtodo") ? KMS_FTODO : KMS_FCALENDAR; 
$eve = ($erz == KMS_FCALENDAR) ? "event" : "task"; 
$axn = ($erz == KMS_FCALENDAR) ? $bsh->toCalendarEvent() : $bsh->toCalendarTodo(); 
unset($bsh); 
if (is_null($axn)) { 
echo "alert('Error: failed to display ".$duh."');"; 
return false; 
} 
if (KMS_MREQUEST == $axn->getMethod() && KMS_FCALENDAR == $erz) { 
cak($axn); 
} 
if (!$esi) 
$esi = esk($axn->getMethod()); 
if ($esi == "request") { 
echo "api.evf = '".$erz."';\n"; 
echo "api.evg = '".$eqt."';\n"; 
echo 'api.document.getElementById("buttonCalendar").setAttribute("ays",' . $axn->getStartDateTime() . ");\n"; 
echo "api.document.getElementById(\"messageToolbarEventPattern\").style.display = 'block';\n"; 
} 
$akm = $axn->getAttendees(); 
foreach ($akm as $axu) { 
$ca0[$axu['role']][] = $axu['address']; 
if (strtolower($axu['address']) == strtolower($apt['address'])) 
$evh = $axu; 
} 
if ($esi == "reply" && count($evh) > 0) { 
$xk = $evh['name'] ." &lt;".$evh['address']."&gt;"; 
$c0r = $evh['status']; 
switch ($evh['status']) { 
case KMS_ASACCEPTED: 
$dxh = "accept.gif"; 
$chg = $xk.' <kerio:text id="mail-'.$eve.'-user-accepted"/>'; 
break; 
case KMS_ASINPROCESS: 
case KMS_ASCOMPLETED: 
case KMS_ASNEEDSACTION: 
case KMS_ASDELEGATED: 
$dxh = "accept.gif"; 
$chg = $xk . ' <kerio:text id="mail-' . $eve . '-user-updated"/>'; 
$c0r = KMS_ASACCEPTED; 
break; 
case KMS_ASTENTATIVE: 
$dxh = "tentative.gif"; 
$chg = $xk.' <kerio:text id="mail-'.$eve.'-user-tentative"/>'; 
break; 
case KMS_ASDECLINED: 
$dxh = "decline.gif"; 
$chg = $xk.' <kerio:text id="mail-'.$eve.'-user-declined"/>'; 
break; 
default: 
echo "alert('unknown status " . $c0r . "');\n"; 
$dxh = ''; 
$chg = ''; 
break; 
} 
$evi = "<img src='gfx/".$dxh."' class='icon'>&nbsp;$chg<br>"; 
$cal = cam("(@MessageId = $1)", array($axn->getUid()), $erz); 
if (count($cal) > 0) { 
$alc = ald($cal[0]['folder'], $erz); 
$aow = alf($alc, $erz, KMS_FAREADWRITE); 
$aow->gotoUid($cal[0]['uid']); 
$evj = ($erz == KMS_FCALENDAR) ? $aow->getCalendarEvent() : $aow->getCalendarTodo(); 
$evk = $evj->copy(); 
$c0z = $evk->getAttendees(); 
$ctz = false; 
for ($bi = 0; $bi < count($c0z); $bi++) { 
if (strtolower($c0z[$bi]['address']) == strtolower($apt['address'])) { 
$ctz = true; 
$c0z[$bi]['status'] = $c0r; 
$evk->setAttendee($c0z[$bi], $bi); 
} 
} 
if (!$ctz) { 
$evk->addAttendee($evh); 
} 
$agr = ($erz == KMS_FCALENDAR) 
? $aow->saveCalendarEvent($evk) 
: $aow->saveCalendarTodo($evk); 
unset($aow); 
if (!$agr) 
echo "<script type='text/javascript'>alert('".'<kerio:text id="mail-'.$eve.'-err-update"/>'.")</script>"; 
} 
echo "api.apo();\n"; 
} 
if ($esi == "cancel") { 
$dxh = "decline.gif"; 
$chg = '<kerio:text id="mail-'.$eve.'-canceled"/>'; 
$evi = "<img src='gfx/".$dxh."' class='icon'>&nbsp;$chg<br>"; 
$cal = cam("(@MessageId = $1)", array($axn->getUid()), $erz); 
if (count($cal) > 0) { 
efx($cal[0]['folder'], $cal[0]['uid'], true, "false"); 
} 
} 
$aqo = "<div style='background-color: #EEEEEE; padding: 4px'>"; 
$aqo.= "<span style='font-size: 16px; font-weight: bold;'>".aiz($axn->getSummary())."</span><br>"; 
if ($esi == 'reply' && count($cal) == 0) { 
$aqo .= '<span style="padding-left:16px;">&nbsp;'; 
$aqo .= ($erz == KMS_FCALENDAR) ? '<kerio:text id="event-is-not-in-calendar"/>' 
: '<kerio:text id="todo-is-not-in-tasks"/>'; 
$aqo .= '</span><br>'; 
} 
$aqo.= $evi; 
$aqo.= "<hr>"; 
if (count($ca0[KMS_ARREQPARTICIPANT]) > 0) 
$aqo.= '<b>' . cai(ajw('eventtodo-attendees-requested')). ':</b> '.aiz(implode(", ", $ca0[KMS_ARREQPARTICIPANT]))."<br>"; 
if (count($ca0[KMS_AROPTPARTICIPANT]) > 0) 
$aqo.= '<b>' . cai(ajw('eventtodo-attendees-optional')) . ':</b> '.aiz(implode(", ", $ca0[KMS_AROPTPARTICIPANT]))."<br>"; 
switch ($erz) { 
case KMS_FCALENDAR: 
$aqo.= '<b><kerio:text id="mail-event-when"/></b>: '.c0t($axn)."<br>" 
. '<b><kerio:text id="eventtodo-location"/></b>: '.aiz($axn->getLocation()); 
break; 
case KMS_FTODO: 
$evl = ($axn->getDueDateTime() > 0) ? ajm("%a %kdate", $axn->getDueDateTime()) : ajw('common-unknown'); 
$aqo.= '<b><kerio:text id="todo-duetime"/></b>: ' . $evl . "<br>" 
. '<b><kerio:text id="todo-status"/></b>: '.c0q($axn->getStatus())."<br>" 
. '<b><kerio:text id="eventtodo-priority"/></b>: '.aso($axn->getPriority())."<br>" 
. '<b><kerio:text id="todo-percent"/></b>: '.$axn->getPercentComplete(); 
break; 
} 
$aqo.= "</div><p>"; 
echo "api.esh(" . apk($aqo) . ");\n"; 
echo "api.esh(\""; 
$epw = aiz($axn->getDescription()); 
if (evm($epw)) $epw = evn($epw, "full"); 
echo arj($epw); 
echo "\");\n"; 
} 
function evo($axn, $erz, $esi) { 
switch ($erz) { 
case KMS_FCALENDAR: 
$evp = array(); 
$evp['content'] = c0x($axn, 'html'); 
$evp['type'] = 'text/html'; 
$evq = array(); 
$evq['content'] = $axn->toString(); 
$evq['type'] = 'text/calendar'; 
$evq['typeAttrs']['component'] = "VEVENT"; 
$evq['typeAttrs']['method'] = $esi; 
$evq['typeAttrs']['name'] = "meeting.ics"; 
$evq['class'] = 'urn:content-classes:calendarmessage'; 
$evr = c0x($axn, 'text'); 
$evs = array($evp, $evq); 
break; 
case KMS_FTODO: 
$evp = array(); 
$evp['content'] = evt($axn, 'html'); 
$evp['type'] = 'text/html'; 
$evq = array(); 
$evq['content'] = $axn->toString(); 
$evq['type'] = 'text/calendar'; 
$evq['typeAttrs']['component'] = "VTODO"; 
$evq['typeAttrs']['method'] = $esi; 
$evq['typeAttrs']['name'] = "task.ics"; 
$evq['class'] = 'urn:content-classes:task'; 
$evr = evt($axn, 'text'); 
$evs = array($evp, $evq); 
break; 
default: 
$evr = ''; 
$evs = array(); 
break; 
} 
$erp = "multipart/alternative"; 
return array('mailBody' => $evr, 'mailAttachments' => $evs, 'contentType' => $erp); 
} 
function egj($anz, $erz, $ahd, $m) { 
$alc = ald($anz, $erz); 
if ($alc) { 
echo asf($alc, $erz, $ahd, $m); 
} 
} 
function asf($alc, $erz, $ahd, $m, $evu = '', $asd = array()) { 
global $l, $o; 
$arz = ''; 
$eve = ($erz == KMS_FCALENDAR) ? "event" : "task"; 
$ale = alf($alc, $erz, KMS_FAREADWRITE); 
if ($ale->gotoUid($ahd)) { 
switch ($erz) { 
case KMS_FCALENDAR: 
$agw = $ale->getCalendarEvent(); 
break; 
case KMS_FTODO: 
$agw = $ale->getCalendarTodo(); 
break; 
default: 
return $arz; 
break; 
} 
} 
else { 
$aos = $alc->getName(); 
ala('E_MESSAGE_BADUID', $aos); 
aox('sendEvent', 'E_MESSAGE_BADUID', 'folder: ' . $aos . '; uid: ' . base_convert($ahd, 10, 16)); 
} 
$axn = $agw->copy(); 
$c0z = $axn->getAttendees(); 
$evv = aui($axn); 
$evw = array(); 
$dju = ''; 
$evx = ''; 
if ($m != 'reply') { 
$evx = aup($evv); 
$evy = $evv['address']; 
$cg = substr(strrchr($evv['address'], '@'), 1); 
if (sizeof($asd) > 0) $c0z = $asd; 
for ($bi = 0; $bi < count($c0z); $bi++) { 
$axu = $c0z[$bi]; 
$apu = $axu['address']; 
if (!$apu) $apu = $axu['name']; 
if (!strstr($apu, '@')) $apu.= '@'.$cg; 
$axu['address'] = $apu; 
$axn->setAttendee($axu, $bi); 
if (!strstr($dju, $apu) && $axu['rsvp'] && !in_array($axu['address'], $o->getAllowedEmailAddresses())) { 
if ($dju) $dju.= ","; 
$dju.= aup($axu); 
$evw[] = $apu; 
} 
} 
if (count($evw) == 0) { 
return $arz; 
} 
} 
elseif ($evu != '') { 
$dju = aup($evv); 
$evw[] = $evv['address']; 
$evz = $o->getAllowedEmailAddresses(); 
$evz = array_unique($evz); 
foreach ($c0z as $akt) { 
if (in_array($akt['address'], $evz)) { 
$evx = aup($akt); 
$ew0 = $akt; 
break; 
} 
} 
if (!$evx) $evx = $evz[0]; 
} 
else { 
return $arz; 
} 
if ($m == "cancelEvent") { 
$ewa = "Canceled: " . $agw->getSummary(); 
$axn->setMethod(KMS_MCANCEL); 
$esi = "CANCEL"; 
$axn->clearAttendees(); 
foreach ($asd as $akt) { 
$axn->addAttendee($akt); 
} 
} 
elseif ($m != 'reply') { 
if ($m == "sendEventUpdatePrompt") $ewb = true; 
if ($m == "sendEventUpdate" || $m == "sendEventUpdatePrompt") $ewc = true; 
$ewa = $agw->getSummary(); 
if ($erz == KMS_FTODO) $ewa = "Task request: ".$ewa; 
if ($ewc) $ewa = "Updated: ".$ewa; 
switch ($agw->getPriority()) { 
case 1: $ewd = "1 (Highest)"; break; 
case 9: $ewd = "5 (Lowest)"; break; 
default: $ewd = ""; 
} 
$c0z = $axn->getAttendees(); 
for ($bi = 0; $bi < count($c0z); $bi++) { 
$axu = $c0z[$bi]; 
$apu = $axu['address']; 
if ($axu['rsvp'] && !in_array($axu['address'], $o->getAllowedEmailAddresses())) { 
$axu['status'] = KMS_ASNEEDSACTION; 
$axu['mailSent'] = true; 
} 
$axn->setAttendee($axu, $bi); 
} 
$agr = ($erz == KMS_FCALENDAR) 
? $ale->saveCalendarEvent($axn) 
: $ale->saveCalendarTodo($axn); 
unset($ale, $alc); 
if (!$agr) { 
$arz .= 'alert(\'<kerio:text id="mail-' . $eve . '-err-update"/>\');' . "\n"; 
return $arz; 
} 
$axn->setMethod(KMS_MREQUEST); 
$esi = "REQUEST"; 
} 
elseif ($evu != '') { 
$ewa = 'Declined: ' . $agw->getSummary(); 
switch ($evu) { 
case 'accepted': $evu = KMS_ASACCEPTED; break; 
case 'declined': $evu = KMS_ASDECLINED; break; 
case 'tentative': $evu = KMS_ASTENTATIVE; break; 
default: 
break; 
} 
$ew0['status'] = $evu; 
$axn->clearAttendees(); 
$axn->addAttendee($ew0); 
$axn->setMethod(KMS_MREPLY); 
$esi = 'REPLY'; 
} 
else { 
return $arz; 
} 
$ewe = evo($axn, $erz, $esi); 
$eug['Message-ID'] = asc($ewa); 
$eug['From'] = kerio_encode_address_header('From', $evx); 
$eug['To'] = kerio_encode_address_header('To', $dju); 
$eug['Subject'] = kerio_encode_header('Subject', $ewa); 
if ('cancelEvent' == $m) { 
$ewd = '1 (Highest)'; 
} 
if ($ewd) { 
$eug['X-Priority'] = $ewd; 
} 
$eur = eus($eug, 
$ewe['mailBody'], 
$ewe['mailAttachments'], 
$ewe['contentType']); 
$ewf = euu($eur, $evy, $evw); 
evc(FLD_SENT, $eur); 
if ($ewb) { 
$arz .= 'alert(\'<kerio:text id="mail-' . $eve . '-sent"/>\');' . "\n" 
. 'api.apo();' . "\n" 
. 'var cnd = api.apl.apm;' 
. 'if (cnd) cnd.apn();' . "\n"; 
} 
if ($m == 'cancelEvent' && sizeof($asd) == 0) { 
$arz .= 'alert(\'<kerio:text id="mail-' . $eve . '-cancel-sent"/>\');' . "\n"; 
} 
if ($m == 'reply' && $evu != '' && $ewf) { 
$arz .= 'alert(\'<kerio:text id="mail-' . $eve . '-decline-sent"/>\');' . "\n"; 
} 
return $arz; 
} 
function egk($aos, $duk, $ewg, $ewh, $ewi) { 
global $l; 
$ewh = ($ewh == 'false') ? false : true; 
$ewi = ($ewi == 'false') ? false : true; 
$ewj = explode(',', $ewg); 
if (sizeof($ewj)) foreach($ewj as $ahd) { 
$agw = dal($aos, $duk, $ahd); 
$xk = $l->getMyUserInfo(); 
$ewk = new ajt($agw, $xk->getAllowedEmailAddresses()); 
if ($ewk->akq() && $ewh) { 
$alc = ald($aos, $duk); 
echo asf($alc, $duk, $ahd, 'cancelEvent'); 
} 
if ($ewk->akr() && $ewi) { 
if (is_null($alc)) { 
$alc = ald($aos, $duk); 
} 
echo asf($alc, $duk, $ahd, 'reply', 'declined'); 
} 
} 
efx($aos, $ewg, false, "false"); 
} 
function ase($aoy, $akm, $m, $aki, $ewl) { 
global $o; 
$ewm = $aoy->getAttendees(); 
$ash = array(); 
$asd = array(); 
$aoy->clearAttendees(); 
$auh = aui($aoy); 
if (!empty($akm)) { 
$ewn = true; 
$ewo = $o->getAllowedEmailAddresses(); 
foreach ($akm as $akt) { 
$ewp = kerio_parse_address_header($akt['name']); 
$ewq = $ewp[0]; 
if (KMS_FCALENDAR == $aki && $ewn && in_array($ewq['address'], $ewo)) { 
if ($ewl || empty($ewm)) { 
$ewn = false; 
continue; 
} 
else { 
$ewr = false; 
foreach ($ewm as $ews) { 
if ($ews['address'] == $auh['address']) { 
$ewr = true; 
break; 
} 
} 
if (!$ewr) { 
$ewn = false; 
continue; 
} 
} 
} 
$akt['address'] = $ewq['address']; 
$akt['name'] = $ewq['name']; 
if ('' == $akt['name']) { 
$akt['name'] = $akt['address']; 
} 
$ash[] = $akt; 
$aoy->addAttendee($akt); 
} 
} 
if ('sendEventUpdate' != $m) { 
return $asd; 
} 
foreach ($ewm as $ews) { 
$ewt = true; 
foreach ($ash as $ewu) { 
if ($ewu['address'] == $ews['address']) { 
$ewt = false; 
break; 
} 
} 
if ($ewt) { 
$asd[] = $ews; 
} 
} 
return $asd; 
} 
function asc($cig) 
{ 
global $l; 
$euk = $l->getServerInfo(); 
$bdt = "<".gmdate("YmdHis")."." . substr(md5(microtime().$cig),0,8) 
. "@".$euk->getHostName().">"; 
return $bdt; 
} 
function axv($crt, $c0y = 'short') 
{ 
if (!is_array($crt) || count($crt) == 0) return false; 
if (!isset($crt['name']) && !isset($crt['address'])) { 
foreach ($crt as $axu) { 
$ug[] = axv($axu, $c0y); 
} 
} else { 
switch ($c0y) { 
case "short": 
$ug[] = (strlen($crt['name']) > 0) ? $crt['name'] : $crt['address']; 
break; 
case 'full_preview': 
$ug[] = (strlen($crt['name']) > 0) ? $crt['name'] . ' <' . $crt['address'] . '>' : $crt['address']; 
break; 
case 'square_preview': 
$ug[] = (strlen($crt['name']) > 0) ? $crt['name'] . ' [mailto:' . $crt['address'] . ']' : $crt['address']; 
break; 
case "full": 
$ug[] = aup($crt); 
break; 
} 
} 
return implode(", ", $ug); 
} 
function esk($esi) { 
switch ($esi) { 
case KMS_MPUBLISH: return "publish"; break; 
case KMS_MREQUEST: return "request"; break; 
case KMS_MREPLY: return "reply"; break; 
case KMS_MADD: return "add"; break; 
case KMS_MCANCEL: return "cancel"; break; 
case KMS_MREFRESH: return "refresh"; break; 
case KMS_MCOUNTER: return "counter"; break; 
case KMS_MDECLINECOUNTER: return "declinecounter"; break; 
default : return false; 
} 
} 
function cam($ewv, $sw, $duk) 
{ 
global $o; 
$aos = "~".$o->getUserName()."/".($duk == KMS_FCALENDAR ? FLD_CALENDAR : FLD_TODO); 
$alc = ald($aos, $duk); 
$av0 = $alc->searchMessages(&$eww, &$avb, $ewv, $sw); 
$ale = alf($alc, $duk); 
$ale->setSubset($eww); 
for ($ale->gotoNumber(0), $bi = 0; $ale->isValid() ; $ale->gotoNext(),++$bi) { 
$agw = ($duk == KMS_FCALENDAR) ? $ale->getCalendarEvent() : $ale->getCalendarTodo(); 
if (!is_null($agw)) 
$aif[] = array("uid"=>$ale->getUID(), "folder"=>$aos); 
} 
unset($alc, $ale); 
return $aif; 
} 
?>
