<?php
define('MODE_DISPLAY_FULL', 1); 
define('MODE_COMPOSE_FULL', 2); 
define('MODE_DISPLAY_MINI', 3); 
define('MODE_DISPLAY_PDA', 4); 
define('MODE_ATTACHMENT', 5); 
define('USE_PHP_PARSER', false); 
define('ALNUM_CTRL_CHARS', '0*[0-9]|0*[12][0-9]|0*3[01]|x0*1?[0-9A-F]|0*6[5-9]|0*[78][0-9]|0*90|x0*4[1-9A-F]|x0*5[0-9A]|0*9[7-9]|0*1[01][0-9]|0*12[0-2]|x0*6[1-9A-F]|x0*7[0-9A]'); 
define('CSS_FILTER_RULES', 1); 
define('SRC_FILTER_RULES', 2); 
define('ATTRIB_FILTER_RULES', 3); 
if (USE_PHP_PARSER) { 
require_once('lowLevelHtmlParser.inc'); 
} 
define('REMOVED', "Removed*By*Webmail"); 
define('REMOVED_CSS', 'removed-by-webmail'); 
define('TAB_SIZE', 8); 
define('TAB_SPACE', "        "); 
define('MAX_WORD_LENGTH' , 1000); 
define('MAX_CONTENT_LENGTH', 200000); 
define('MAX_CSS_LENGTH_TOTAL', 10000); 
define('MAX_CSS_LENGTH_RULE', 2000); 
define('ATTACHMENT_GENERIC_NAME', 'file'); 
define('ATTACHMENT_GENERIC_EXT' , '.'); 
$equ = array( 
'folder' => '', 
'uid' => '', 
'from' => '', 
'cidsShownInline' => array() 
); 
function esc($erx) { 
$erx = trim($erx); 
if ($erx != '') { 
if ($erx == '.') { 
$erx = '_'; 
} 
elseif ($erx == '..') { 
$erx = '__'; 
} 
else { 
$erx = strtr($erx, "\\/:*?<>|\"", "_________"); 
} 
if (strpos($erx, '.') === false) { 
$erx .= ATTACHMENT_GENERIC_EXT; 
} 
return hye($erx); 
} 
else { 
return ATTACHMENT_GENERIC_NAME . ATTACHMENT_GENERIC_EXT; 
} 
} 
function ery($bsh) { 
$ers = $bsh->getContentDispositionAttributes(); 
foreach ($ers as $axu) { 
if (strcasecmp($axu['name'], 'filename') == 0) return $axu['value']; 
} 
$ers = $bsh->getContentTypeAttributes(); 
foreach ($ers as $axu) { 
if (strcasecmp($axu['name'], 'name') == 0) return $axu['value']; 
} 
return false; 
} 
function hyf($gyf) { 
if (strpos($gyf, '{') === false || strpos($gyf, '}') === false || strpos($gyf, ':') === false) { 
return true; 
} 
$chz = strlen($gyf); 
if ($chz < MAX_CSS_LENGTH_TOTAL) { 
return false; 
} 
$cgu = 0; 
$hyg = '{'; 
while ($cgu < $chz) { 
$hyh = strpos($gyf, $hyg, $cgu); 
if ($hyh === false) { 
$hyh = $chz; 
} 
if ($hyh - $cgu > MAX_CSS_LENGTH_RULE) { 
return true; 
} 
$cgu = $hyh; 
$hyg = ($hyg == '{' ? '}' : '{'); 
} 
return false; 
} 
function hyi($gyf) { 
if (hyf($gyf)) { 
return ''; 
} 
$dtp = ""; 
if (preg_match_all("/\s*([^{}]+)\s*{\s*([^{}]+)\s*}/si", $gyf, $hyj)) { 
$eaz = count($hyj[1]); 
$dtp = ""; 
for ($bi = 0; $bi < $eaz; $bi++) { 
$dtp[$hyj[1][$bi]] = $hyj[2][$bi]; 
} 
} 
return $dtp; 
} 
function hyk($hyl, $ark) { 
$dtp = ""; 
if (is_array($hyl)) foreach ($hyl as $cie => $fi) { 
if ($cie == "*" || strcasecmp($cie, "body") == 0) { 
$cie = $ark; 
} 
else { 
$cie = $ark . " " . str_replace(",", "," . $ark . " ", $cie); 
} 
$dtp[$cie] = $fi; 
} 
return $dtp; 
} 
function hym($hyl) { 
$dtp = ""; 
if (is_array($hyl)) foreach ($hyl as $cie => $fi) { 
$dtp .= "\n " . $cie . " {" . $fi . "}"; 
} 
return $dtp; 
} 
function hyn($hyo) { 
switch ($hyo) { 
case CSS_FILTER_RULES: 
$dvz = array( 
'/expression/i' => REMOVED, 
'/res:\/\//i' => REMOVED, 
'/sysimage:\/\//i' => REMOVED, 
'/data:/i' => REMOVED, 
'/jar:/i' => REMOVED, 
'/position/i' => REMOVED_CSS, 
'/-moz-binding/i' => REMOVED_CSS 
); 
break; 
case SRC_FILTER_RULES: 
$dvz = array( 
'/^\s*res:\/\//i' => REMOVED, 
'/^\s*sysimage:\/\//i' => REMOVED, 
'/^\s*data:/i' => REMOVED, 
'/^\s*jar:/i' => REMOVED 
); 
break; 
} 
$dvz['/S\s*C\s*R\s*I\s*P\s*T\s*:/Si'] = REMOVED . ':'; 
$dvz['/(&#)(' . ALNUM_CTRL_CHARS . ')([^0-9A-F])/Usi'] = "\\1 \\2\\3"; 
return $dvz; 
} 
function hyp($hxj) { 
global $equ; 
$euw = strtolower(trim(substr($hxj, 4))); 
$equ['cidsShownInline'][] = '<' . $euw . '>'; 
$ese = '../default/mailAttach.php?folder=' . urlencode($equ['folder']) . '&uid=' . $equ['uid'] . '&cid=' . $euw; 
return $ese; 
} 
function hyq($hyr, $hys) { 
$cgo = '/url\s*\((' . ($hys ? '\s*cid:' : '') . '[^\)]+)\)/Usi'; 
return preg_replace_callback($cgo, 'hyt', $hyr); 
} 
function hyt($matches) { 
$cid = trim($matches[1]); 
if (strtolower(substr($cid, 0, 4)) == 'cid:') { 
$hyu = 'url("' . hyp($cid) . '")'; 
} 
else { 
$hyu = 'none'; 
} 
return $hyu; 
} 
function hyv($hyr, $hyw, $hyx) { 
$hyr = str_replace('\\', '/', $hyr); 
$hyr = str_replace(array('/*', '*/'), REMOVED, $hyr); 
$hyr = preg_replace($hyw, $hyx, $hyr); 
return $hyr; 
} 
function hyy($hyl, $dmm, $hys) { 
$dtp = array(); 
if (is_array($hyl)) { 
$hyz = hyn(CSS_FILTER_RULES); 
$hyw = array_keys($hyz); 
foreach ($hyl as $cie => $fi) { 
$fi = hyv($fi, $hyw, $hyz); 
$fi = hyq($fi, $hys); 
$dtp[$cie] = $fi; 
} 
} 
return $dtp; 
} 
function evm(&$cry) { 
$hz0 = strlen($cry); 
if ($hz0 >= MAX_CONTENT_LENGTH) return false; 
$hza = 0; 
$hzb = -1; 
while ($hza !== false && $hzb < $hz0) { 
$hzb += $hza + 1; 
$hza = strrpos(substr($cry, $hzb, MAX_WORD_LENGTH), " "); 
} 
return ($hz0 - $hzb <= MAX_WORD_LENGTH); 
} 
function evn($cry, $dmm) { 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
$hyu = '<a href="javascript:cnb(\'new\',\'\\1\')" onmouseover="window.status=\'\';return true;" onclick="window.status=\'\';return true;">\\1</a>'; 
$etc = ' defaultcontextmenu="yes"'; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$hyu = '<a href="compose.php?mailTo=\\1">\\1</a>'; 
$etc = ''; 
break; 
case MODE_COMPOSE_FULL: 
default: 
$hyu = '<a href="mailto:\\1">\\1</a>'; 
$etc = ''; 
break; 
} 
if (strpos($cry, '://') !== false) { 
$hzc = preg_split('~(https?|ftp)://~i', $cry, -1, PREG_SPLIT_DELIM_CAPTURE); 
$hzd = (count($hzc) - 1) / 2; 
$cry = $hzc[0]; 
for ($bi = 0; $bi < $hzd; $bi++) { 
$cie = 2 * $bi + 1; 
$hze = $hzc[$cie] . '://'; 
$hzf = $hzc[$cie + 1]; 
if (trim($hzf) == '') { 
$cry .= $hze . $hzf; 
continue; 
} 
$hzf = preg_split('~\s~', $hzf, 2); 
$hzg = $hzf[0]; 
$atn = (isset($hzf[1]) ? ' ' . $hzf[1] : ''); 
$hzh = strpos($hzg, '&gt;'); 
$hzi = strpos($hzg, '&lt;'); 
if ($hzh !== false) { 
$hzj = ($hzi !== false && $hzi < $hzh) ? $hzi : $hzh; 
} 
else { 
$hzj = $hzi; 
} 
if ($hzj !== false) { 
$hzg = substr($hzf[0], 0, $hzj); 
$atn = substr($hzf[0], $hzj) . $atn; 
} 
$awr = substr($hzg, -1); 
switch ($awr) { 
case '.': 
case ',': 
case ':': 
case '?': 
case '!': 
case ')': 
$hzg = substr($hzg, 0, -1); 
$atn = $awr . $atn; 
break; 
case ']': 
if (substr($hzc[$cie - 1], -1) == '[') { 
$hzg = substr($hzg, 0, -1); 
$atn = $awr . $atn; 
} 
break; 
default: 
break; 
} 
$hzg = str_replace('@', '&#64;', $hzg); 
$cry .= '<a href="' . $hze . str_replace('"', '%22', $hzg) . '" target="_blank"' . $etc . '>' . 
$hze . $hzg . '</a>' . $atn; 
} 
} 
if (strpos($cry, '@') !== false) { 
$hzk = '/([a-z0-9_!=\+-]+(\.[a-z0-9_!=\+-]+)*@[a-z0-9_-]+(\.[a-z0-9_-]+)*)/i'; 
$cry = preg_replace($hzk, $hyu, $cry); 
} 
return $cry; 
} 
function etr(&$gyf) { 
$dtp = ''; 
if (preg_match('/<meta[^>]*charset\s*=[\s\'"]*([^\s\'">]*)/si', $gyf, $hyj)) { 
$dtp = strtolower($hyj[1]); 
if ($dtp == 'utf-16') { 
$dtp = ''; 
} 
} 
elseif (preg_match('/\0<\0m\0e\0t\0a[^>]*\0c\0h\0a\0r\0s\0e\0t[\0\s]*\0=[\0\s\'"]*([^\s\'">]*)/si', $gyf, $hyj)) { 
$dtp = strtolower(preg_replace('/\0/', '', $hyj[1])); 
} 
return $dtp; 
} 
function hye($hzl) { 
$dtp = ""; 
$eaz = mb_strlen($hzl); 
for ($bi = 0; $bi < $eaz; $bi++) { 
$hzm = mb_substr($hzl, $bi, 1); 
$dtp .= (strlen($hzm) > 1 ? $hzm : rawurlencode($hzm)); 
} 
return $dtp; 
} 
function hzn(&$hwg, $hzo) { 
$hzp = array('text' => array(), 'css' => array()); 
foreach ($hzo as $hxk) { 
$hzp[$hxk] = array(); 
} 
$hzq = true; 
$hzr = false; 
foreach ($hwg as $cie => $adg) { 
switch ($adg['type']) { 
case KMS_HTML_TAG: 
if (in_array($adg['value'], $hzo)) $hzp[$adg['value']][] = $cie; 
if ($adg['value'] == "a") { 
$hzq = false; 
} 
elseif ($adg['value'] == "style") { 
$hzr = true; 
} 
break; 
case KMS_HTML_ENDTAG: 
if (in_array($adg['value'], $hzo)) $hzp[$adg['value']][] = -1 * $cie; 
if ($adg['value'] == "a") { 
$hzq = true; 
} 
elseif ($adg['value'] == "style") { 
$hzr = false; 
} 
break; 
case KMS_HTML_TEXT: 
if ($hzr) { 
$hzp['css'][] = $cie; 
} 
elseif ($hzq) { 
$hzp['text'][] = $cie; 
} 
break; 
case KMS_HTML_COMMENT: 
if ($hzr) { 
$hzp['css'][] = $cie; 
} 
break; 
} 
} 
return $hzp; 
} 
function hzs(&$hwg, $hzt, $hys) { 
$hzu = array(); 
$hzv = false; 
$hzw = false; 
foreach ($hwg as $cie => $adg) { 
switch ($adg['type']) { 
case KMS_HTML_TAG: 
$hzw = ($adg['value'] == 'style' || $adg['value'] == 'title'); 
$hzv = in_array($adg['value'], $hzt); 
if (!$hzv && array_key_exists('attrib', $adg)) { 
$adg['attrib'] = hzx($adg['attrib'], $hys); 
} 
break; 
case KMS_HTML_ENDTAG: 
if ($hzw && ($adg['value'] == 'style' || $adg['value'] == 'title')) { 
$hzw = false; 
} 
$hzv = in_array($adg['value'], $hzt); 
if (array_key_exists('attrib', $adg)) unset($adg['attrib']); 
break; 
case KMS_HTML_TEXT: 
$hzv = $hzw; 
break; 
case KMS_HTML_COMMENT: 
$hzv = true; 
break; 
} 
if (!$hzv) $hzu[$cie] = $adg; 
} 
return $hzu; 
} 
function hzx(&$hzy, $hys) { 
$hyz = hyn(CSS_FILTER_RULES); 
$hyw = array_keys($hyz); 
$hzz = hyn(SRC_FILTER_RULES); 
$i00 = array_keys($hzz); 
$i0a = hyn(ATTRIB_FILTER_RULES); 
$i0b = array_keys($i0a); 
$i0c = array(); 
foreach ($hzy as $hxi => $hxj) { 
if ($hxj == "") { 
$i0c[$hxi] = ''; 
continue; 
} 
$hxj = str_replace("\\", "/", $hxj); 
switch ($hxi) { 
case 'href': 
case 'src': 
$hxj = preg_replace($i00, $hzz, $hxj); 
$i0d = false; 
break; 
case 'style': 
$hxj = hyv($hxj, $hyw, $hyz); 
$hxj = hyq($hxj, $hys); 
$i0d = false; 
break; 
case 'background': 
if (strtolower(substr($hxj, 0, 4)) == 'cid:') { 
$hxj = hyp($hxj); 
$i0d = false; 
} 
elseif (!$hys) { 
$i0d = true; 
} 
else { 
$hxj = preg_replace($i00, $hzz, $hxj); 
$i0d = false; 
} 
break; 
default: 
$hxj = preg_replace($i0b, $i0a, $hxj); 
$i0d = false; 
break; 
} 
if (!$i0d) { 
$i0c[$hxi] = $hxj; 
} 
} 
return $i0c; 
} 
function i0e(&$hwg) { 
$i0f = 0; 
$i0g = false; 
foreach ($hwg as $cie => $adg) { 
switch ($adg['type']) { 
case KMS_HTML_TEXT: 
break; 
case KMS_HTML_TAG: 
switch ($adg['value']) { 
case 'table': 
if ($i0g) { 
unset($hwg[$cie]); 
} 
else { 
$i0f++; 
$i0g = true; 
} 
break; 
case 'td': 
case 'th': 
if ($i0f > 0) { 
$i0g = false; 
} 
else { 
unset($hwg[$cie]); 
} 
break; 
case 'tr': 
case 'tbody': 
case 'thead': 
case 'tfoot': 
case 'caption': 
case 'col': 
case 'colgroup': 
if ($i0f == 0) { 
unset($hwg[$cie]); 
} 
break; 
} 
break; 
case KMS_HTML_ENDTAG: 
switch ($adg['value']) { 
case 'table': 
if ($i0f > 0) { 
$i0f--; 
$i0g = false; 
} 
else { 
unset($hwg[$cie]); 
} 
break; 
case 'td': 
case 'th': 
case 'tr': 
case 'tbody': 
case 'thead': 
case 'tfoot': 
case 'caption': 
if ($i0f == 0) { 
unset($hwg[$cie]); 
} 
else { 
$i0g = true; 
} 
break; 
} 
break; 
} 
} 
$i0h = array( 
'type' => KMS_HTML_ENDTAG, 
'value' => 'table' 
); 
for ($bi = 1; $bi <= $i0f; $bi++) { 
$hwg[] = $i0h; 
} 
} 
function i0i(&$hwg, $hzp) { 
foreach ($hzp['css'] as $cie) { 
$i0j .= $hwg[$cie]['value']; 
} 
foreach ($hzp['body'] as $cie) { 
if ($cie > 0) { 
if (array_key_exists('attrib', $hwg[$cie])) $i0j .= i0k($hwg[$cie]['attrib']); 
break; 
} 
} 
return preg_replace(array("/\/\*.*\*\//Usi", "/<.*>/si", "/\s+/s", "/\s*([{},;:])\s*/"), array("", "", " ", "\\1"), $i0j); 
} 
function i0k($hzy) { 
$dtp = "\n*{"; 
foreach ($hzy as $hxi => $hxj) { 
if ($hxj == "") continue; 
switch ($hxi) { 
case "bgcolor": 
$i0l = strtolower($hxj); 
if ($i0l == '#ffffff' || $i0l == 'white') { 
break; 
} 
$dtp .= "background-color" . ":" . $hxj . ";"; 
break; 
case "text": $dtp .= "color" . ":" . $hxj . ";"; break; 
case "leftmargin": $dtp .= "margin-left" . ":" . $hxj . "px;"; break; 
case "topmargin": $dtp .= "margin-right" . ":" . $hxj . "px;"; break; 
case "style": $dtp .= $hxj . (substr($hxj, -1) == ";" ? "" : ";"); break; 
} 
} 
return $dtp . "}"; 
} 
function i0m(&$hwg, $hzp) { 
if (count($hzp['base']) == 0) return ""; 
$eaz = count($hzp['head']); 
$bi = 0; 
while ($bi < $eaz && $hzp['head'][$bi] < 0) $bi++; 
$i0n = $hzp['head'][$bi]; 
while ($bi < $eaz && $hzp['head'][$bi] > 0) $bi++; 
$i0o = abs($hzp['head'][$bi]); 
foreach ($hzp['base'] as $cie) { 
if ($cie > $i0n && $cie < $i0o && array_key_exists('attrib', $hwg[$cie])) { 
$fdx = $hwg[$cie]['attrib']['href']; 
if ($fdx != "") return $fdx; 
} 
} 
return ""; 
} 
function i0p(&$hwg, $hzp) { 
$eaz = count($hzp['title']); 
for ($bi = 0; $bi < $eaz; $bi++) { 
if ($hzp['title'][$bi] > 0) { 
$cie = $hzp['title'][$bi] + 1; 
break; 
} 
} 
if (!isset($cie)) { 
return ''; 
} 
return ($hwg[$cie]['type'] == KMS_HTML_TEXT ? $hwg[$cie]['value'] : ''); 
} 
function i0q(&$hwg, $hzp, $i0r) { 
if (substr($i0r, -1) != "/") $i0r .= "/"; 
foreach ($hzp['img'] as $cie) { 
$fdx = $hwg[$cie]['attrib']['src']; 
if ($fdx != "" && !preg_match("/^(cid:|https*:)/si", $fdx)) { 
$fdx = (substr($fdx, 0, 1) != "/" ? $fdx : substr($fdx, 1)); 
$hwg[$cie]['attrib']['src'] = $i0r . $fdx; 
} 
} 
foreach ($hzp['a'] as $cie) { 
if ($cie < 0) continue; 
$fdx = $hwg[$cie]['attrib']['href']; 
if ($fdx != "" && !preg_match("/^(https*:|ftp:|mailto:|file:|#)/si", $fdx)) { 
$fdx = (substr($fdx, 0, 1) != "/" ? $fdx : substr($fdx,1)); 
$hwg[$cie]['attrib']['href'] = $i0r . $fdx; 
} 
} 
} 
function i0s(&$hwg, $hzp, $dmm) { 
foreach ($hzp['a'] as $cie) { 
if ($cie < 0) continue; 
if (!isset($hwg[$cie]['attrib']['href'])) { 
continue; 
} 
if (substr($hwg[$cie]['attrib']['href'], 0, 1) !== "#") { 
$hwg[$cie]['attrib']['target'] = "_blank"; 
if (!preg_match("/^[a-z]+:/i", $hwg[$cie]['attrib']['href'])) { 
$hwg[$cie]['attrib']['href'] = "http://" . $hwg[$cie]['attrib']['href']; 
} 
} 
else { 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
$hwg[$cie]['attrib']['class'] = "noHref"; 
$hwg[$cie]['attrib']['onclick'] = "g0r('messageArea', '" . substr($hwg[$cie]['attrib']['href'], 1) . "');"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
default: 
break; 
} 
} 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
$hwg[$cie]['attrib']['defaultcontextmenu'] = "yes"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
default: 
break; 
} 
} 
} 
function i0t(&$hwg, $hzp, $dmm, $hys) { 
global $equ; 
switch ($dmm) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$ese = "../default/"; 
break; 
case MODE_ATTACHMENT: 
$ese = '../'; 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
$ese = ""; 
break; 
} 
$ese .= "mailAttach.php?folder=" . urlencode($equ['folder']) . "&uid=" . $equ['uid'] . "&cid="; 
foreach ($hzp['img'] as $cie) { 
if (substr($hwg[$cie]['attrib']['src'], 0, 4) == "cid:") { 
$equ['cidsShownInline'][] = strtolower("<" . substr($hwg[$cie]['attrib']['src'], 4) . ">"); 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_ATTACHMENT: 
$hwg[$cie]['attrib']['src'] = $ese . substr($hwg[$cie]['attrib']['src'], 4); 
break; 
case MODE_COMPOSE_FULL: 
default: 
break; 
} 
} 
elseif (!$hys) { 
unset($hwg[$cie]); 
} 
} 
} 
function i0u(&$hwg, $hzp, $dmm) { 
foreach ($hzp['text'] as $cie) { 
if (isset($hwg[$cie])) { 
$hwg[$cie]['value'] = evn($hwg[$cie]['value'], $dmm); 
} 
} 
} 
function i0v($cid, $aiq) { 
$dtp = ""; 
while (mb_strlen($cid) > $aiq) { 
$hz0 = $aiq; 
$axt = mb_substr($cid, 0, $hz0); 
$ahr = mb_strrpos($axt, " "); 
if ($ahr > 0) { 
$axt = mb_substr($cid, 0, $ahr); 
$hz0 = $ahr + 1; 
} 
else { 
$ahr = mb_strrpos($axt, "&"); 
if ($ahr > 0) { 
$axt = mb_substr($cid, 0, $ahr); 
$hz0 = $ahr; 
} 
} 
$dtp .= $axt . " "; 
$cid = mb_substr($cid, $hz0); 
} 
return $dtp . $cid; 
} 
function i0w($cry, $dmm) { 
if (strlen($cry) >= MAX_CONTENT_LENGTH) { 
return nl2br(aiz($cry)); 
} 
$i0x = evm($cry); 
$i0y = explode("\n", $cry); 
$cry = ''; 
foreach ($i0y as $cah) { 
if (strpos($cah, "\t") !== false) { 
$i0z = explode("\t", $cah); 
$ia0 = count($i0z) - 1; 
$cah = ''; 
for ($bi = 0; $bi < $ia0; $bi++) { 
$crf = $i0z[$bi]; 
$cah .= $crf . substr(TAB_SPACE, 0, TAB_SIZE - (mb_strlen($crf) % TAB_SIZE)); 
} 
$cah .= $i0z[$ia0]; 
} 
$cah = aiz($cah); 
if ($i0x) { 
$cah = evn($cah, $dmm); 
} 
if (substr($cah, 0, 1) == ' ') { 
$cah = '&nbsp;' . substr($cah, 1); 
} 
$cah = str_replace('  ', ' &nbsp;', $cah); 
$cry .= '<br>' . $cah; 
} 
return substr($cry, strlen('<br>')); 
} 
function etw($cry, $erp, $dmm, $eqt = '0', $hys = false) { 
switch (strtolower($erp)) { 
case "text/html": 
if ($dmm != MODE_COMPOSE_FULL) { 
$ett = etr($cry); 
if ($ett == 'utf-16') { 
$cry = kerio_convert($ett, 'utf-8', $cry); 
$ett = 'utf-8'; 
} 
} 
$hwk = Array( 
'blackPairList' => Array('iframe','script','textarea'), 
'whiteTagList' => Array('a','address','b','base','big','blockquote','body','br','caption','center','cite','code','col','colgroup','dd','dir','div','dl','dt','em','font','fieldset','h1','h2','h3','h4','h5','h6','head','hr','html','i','img','legend','li','meta','ol','option','p','pre','q','s','samp','select','small','span','strike','strong','style','sub','sup','table','tbody','td','tfoot','th','thead','title','tr','tt','u','ul','xmp'), 
'whiteAttribList' => Array('align','alt','background','bgcolor','border','cellspacing','cellpadding','class','clear','color','colspan','content','face','height','hspace','href','http-equiv','id','leftmargin','name','nowrap','rowspan','size','src','style','text','title','topmargin','type','valign','vspace','width') 
); 
$hzt = Array('base','body','head','html','meta','style','title'); 
if (!USE_PHP_PARSER) { 
$iaa = kerio("KMS::HTMLParser"); 
$iaa->setPairBlacklist($hwk['blackPairList']); 
$iaa->setTagWhitelist($hwk['whiteTagList']); 
$iaa->setAttribWhitelist($hwk['whiteAttribList']); 
$hwg = $iaa->parse('<!---->' . $cry); 
} 
else { 
$iaa = new hwd($cry, $hwk); 
$hwg = $iaa->hwt(); 
} 
$hzp = hzn($hwg, ($dmm != MODE_ATTACHMENT ? 
array('head','base','body','a','img') : 
array('head','base','body','a','img', 'title') 
)); 
$i0j = i0i($hwg, $hzp); 
$iab = i0m($hwg, $hzp); 
if ($dmm == MODE_ATTACHMENT) { 
$fdm = ($ett != '' ? 
'<meta http-equiv="Content-Type" content="text/html; charset=' . aiz($ett) . '">' : 
'' 
); 
$bsf = i0p($hwg, $hzp); 
if ($bsf != '') { 
$fdm .= '<title>' . aiz($bsf) . '</title>'; 
} 
} 
$hwg = hzs($hwg, $hzt, $hys); 
if ($iab != "") { 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_COMPOSE_FULL: 
i0q($hwg, $hzp, $iab); 
break; 
case MODE_ATTACHMENT: 
$fdm .= '<base href="' . aiz($iab) . '">'; 
break; 
default: 
break; 
} 
} 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
i0s($hwg, $hzp, $dmm); 
break; 
case MODE_COMPOSE_FULL: 
case MODE_ATTACHMENT: 
default: 
break; 
} 
i0t($hwg, $hzp, $dmm, $hys); 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_COMPOSE_FULL: 
if (evm($cry)) i0u($hwg, $hzp, $dmm); 
break; 
case MODE_ATTACHMENT: 
default: 
break; 
} 
switch ($dmm) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
i0e($hwg); 
break; 
} 
if (!USE_PHP_PARSER) { 
$cry = $iaa->getHtml($hwg); 
} 
else { 
$cry = 'PHP parser::' . $iaa->hxg($hwg); 
} 
unset($hwg); 
$hyl = hyy(hyi($i0j), $dmm, $hys); 
switch ($dmm) { 
case MODE_DISPLAY_FULL: 
$iac = MAIN_CONTENT_SELECTOR . str_replace('.', '_', $eqt); 
$hyl = hyk($hyl, '#' . $iac); 
$cry = 
"\n<div id='" . $iac . "'>" . $cry . '</div>' . 
"<style>" . hym($hyl) . "\n</style>\n"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$hyl = hyk($hyl, "#" . MAIN_CONTENT_SELECTOR . $eqt); 
print "\n<style>" . hym($hyl) . "\n</style>\n"; 
break; 
case MODE_ATTACHMENT: 
$fdm .= '<style>' . hym($hyl) . '</style>'; 
$cry = '<html><head>' . $fdm . '</head><body>' . $cry . '</body></html>'; 
break; 
case MODE_COMPOSE_FULL: 
default: 
$cry .= "</blockquote><style>" . hym($hyl) . "\n</style>\n"; 
break; 
} 
break; 
case "text/plain": 
$cry = i0w($cry, $dmm); 
switch ($dmm) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$cry = "<tt>" . $cry . "</tt>"; 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
$cry = "<span style='font:90% monospace;margin-top:0px;'>" . $cry . "</span>"; 
break; 
} 
break; 
case "text/enriched": 
$cry = preg_replace("/([^\n])\r\n([^\r])/s", "\\1 \\2", $cry); 
$cry = preg_replace("/\r\n(\r\n){1,}/sU", "\\1", $cry); 
$cry = preg_replace("|<param.*</param>|Usi", "", $cry); 
$cry = strip_tags($cry); 
switch ($dmm) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$cry = nl2br($cry); 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
break; 
} 
break; 
default: 
$cry = 'Error: invalid Content-Type ' . $erp . '!'; 
break; 
} 
if ($dmm == MODE_DISPLAY_PDA) { 
$cry = preg_replace("/&nbsp;/", " ", $cry); 
$cry = '<!-- -->' . preg_replace("/(<\/*)PRE[^>]*>/si", "\\1p>", $cry); 
preg_match_all("/(<[^>]*>)([^<]*)/si", $cry, $dtp, PREG_SET_ORDER); 
$cry = ""; 
foreach ($dtp as $iad) { 
$cry .= $iad[1] . i0v($iad[2], PDA_DETAIL_LENGTH, " ", 1); 
} 
} 
return $cry; 
} 
?>