<?php
require_once('../default/lib/folder.inc'); 
function dhb($ibr) { 
switch ($ibr) { 
case FLD_INBOX: return kerio_translate($_SESSION['lang'], "fld-inbox"); 
case FLD_SENT: return kerio_translate($_SESSION['lang'], "fld-sent"); 
case FLD_DRAFT: return kerio_translate($_SESSION['lang'], "fld-drafts"); 
case FLD_JUNK: return kerio_translate($_SESSION['lang'], "fld-junk"); 
case FLD_TRASH: return kerio_translate($_SESSION['lang'], "fld-trash"); 
case FLD_CONTACT: return kerio_translate($_SESSION['lang'], "fld-contacts"); 
case FLD_CALENDAR: return kerio_translate($_SESSION['lang'], "fld-calendar"); 
case FLD_TODO: return kerio_translate($_SESSION['lang'], "fld-tasks"); 
case FLD_PUBLIC: return kerio_translate($_SESSION['lang'], "fld-public"); 
case FLD_ARCHIVE: return kerio_translate($_SESSION['lang'], "fld-archive"); 
} 
return kerio_convert("utf-7m", "utf-8", $ibr); 
} 
function dzm($l, $ioe, $icd, $duk) { 
if ($icd == "") return false; 
if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $icd)) { 
iec(1401, "invalid character"); return false; 
} 
elseif (strlen($icd) > 512) { 
iec(1401, "too long folder name"); return false; 
} 
$akw = $l->getFolderStore(); 
if ($akw->createFolder($ioe . "/" . $icd, $duk) != 0) { 
iec(1401, array($ioe, $icd)); return false; 
} 
return true; 
} 
function dzg($l, $dzc, $dz0, $dxe = "") { 
if ($dz0 == "" || $dzc == $dz0 || dzd($dzc, WME_MY_FOLDER)) return false; 
if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $dxe)) { 
iec(1411, "invalid character"); return false; 
} 
elseif (strlen($dxe) > 512) { 
iec(1411, "too long folder name"); return false; 
} 
$akw = $l->getFolderStore(); 
if ($akw->renameFolder($dzc, $dz0) != 0) { 
iec(1411, array($dzc, $dz0)); return false; 
} 
return true; 
} 
function dzk($l, $ibr) { 
if (dzd($ibr, WME_MY_FOLDER)) return false; 
$akw = $l->getFolderStore(); 
if ($akw->deleteFolder($ibr, true) != 0) { 
iec(1421, $ibr); return false; 
} 
return true; 
} 
function dyx($l, $dyy, $iof) { 
$akw = $l->getFolderStore(); 
$ibr = $iof . strrchr($dyy, "/"); 
$dz0 = $ibr; 
$dza = 1; 
while ($akw->folderExists($dz0)) { 
$dz0 = $ibr . $dza++; 
} 
return $dz0; 
} 
function ice($l) { 
$o = $l->getMyUserInfo(); 
$ibr = "~" . $o->getUserName() . "/" . FLD_TRASH . "/" . FLD_CONTACT; 
$akw = $l->getFolderStore(); 
$alc = $akw->openFolder($ibr, FLD_CONTACT); 
if (is_null($alc)) { 
if ($akw->createFolder($ibr, KMS_FCONTACT) != 0) return ""; 
} 
return $ibr; 
} 
function idp($up, $aki) { 
switch ($aki) { 
case 'U': 
$dvw = explode('@', $up); 
$eaz = count($dvw); 
switch ($eaz) { 
case 1: 
$iog = kerio_is_valid_username($up); 
break; 
case 2: 
$iog = (kerio_is_valid_username($dvw[0]) && kerio_is_valid_domainname($dvw[1])); 
break; 
default: 
$iog = false; 
break; 
} 
if (!$iog) { 
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-username-or-email"/>'; 
return false; 
} 
break; 
case 'G': 
if (preg_match('/[,\[\]]/', $up)) { 
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-group"/>'; 
return false; 
} 
break; 
case 'D': 
if (!kerio_is_valid_domainname($up)) { 
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-domain"/>'; 
return false; 
} 
break; 
} 
return true; 
} 
function idr($l, $ibr, $p, $dzy) { 
if ($ibr == "" || $p == "") { 
return; 
} 
$akw = $l->getFolderStore(); 
if ($dzy == WME_REMOVE_ALL_RIGHTS) { 
foreach ($p as $xk) { 
$cri = $akw->deleteFolderAcl($ibr, $xk); 
} 
} 
else { 
if ((strpos($p, "@") === false && $p != "anyone" && $p != "authuser") || ($p == "authuser@")) { 
$o = $l->getMyUserInfo(); 
$gvg = $o->getUserName(); 
$p = ($p == "authuser@" ? "authuser" : $p) . strstr($gvg, "@"); 
} 
if ($p == $gvg) return; 
if (!$akw->setFolderAcl($ibr, $p, ($dzy == "R" ? "lr" : ($dzy == "E" ? "lrswid" : "lrswicda")))) { 
iec(1451, array($ibr, $p, $dzy)); 
} 
} 
} 
function ids($l, $p) { 
if ($p == "") return false; 
$ioh = false; 
$ioi = 0; 
if (strpos($p, "@") === false) { 
$o = $l->getMyUserInfo(); 
$p .= strstr($o->getUserName(), "@"); 
} 
if (substr($p, 0, 1) !== "~") $p = "~" . $p; 
$akw = $l->getFolderStore(); 
$cwh = $akw->listFolders($p . "/*", KMS_FANY, 0); 
$ioj = $akw->getSharedFolderMappings(); 
foreach ($cwh as $alc) { 
if ($alc['type'] != KMS_FMAIL && $alc['type'] != KMS_FCONTACT) continue; 
$ioi++; 
if ((in_array($alc['name'], $ioj)) === false) { 
if (!$akw->mapSharedFolder($alc['name'])) $ioh = true; 
} 
} 
if ($ioh) iec(1461, $p); 
return $ioi; 
} 
function idu($l, $ibr, $iok) { 
$akw = $l->getFolderStore(); 
if ($iok) { 
$cwh = $akw->listFolders($ibr . "/*", KMS_FANY, 0); 
if (count($cwh)) foreach ($cwh as $alc) { 
$akw->unmapSharedFolder($alc['name']); 
} 
} 
else { 
$akw->unmapSharedFolder($ibr); 
} 
} 
function idt($l, $p) { 
$o = $l->getMyUserInfo(); 
$iol = $o->getUserName(); 
if (strpos($p, "@") === false) $p.= strstr($iol, "@"); 
$akw = $l->getFolderStore(); 
$cwh = $akw->listFolders("~" . $iol . "/~" . $p . "/*", KMS_FANY, 0); 
foreach ($cwh as $alc) { 
if ($alc['isSelectable'] && ($alc['type'] == KMS_FMAIL || $alc['type'] == KMS_FCONTACT)) return $alc['name']; 
} 
return ""; 
} 
function ias($l) { 
$akw = $l->getFolderStore(); 
$o = $l->getMyUserInfo(); 
$cwh = $akw->listFolders("~" . $o->getUserName() . "/*", KMS_FANY, 0); 
$iom = $akw->getSharedFolderMappings(); 
$dvz = ""; 
foreach ($cwh as $alc) { 
$dvz[] = array( 
'name' => $alc['name'], 
'nameLocal' => "", 
'subList' => substr_count($alc['name'], "/") - 1, 
'rights' => ($alc['isShared'] ? "S" : (strpos($alc['myRights'], "a") !== false ? "A" : (strpos($alc['myRights'], "d") !== false ? "E" : "R"))), 
'type' => ($alc['isSelectable'] ? $alc['type'] : WME_NOT_SELECTABLE), 
'unseen' => ($alc['isSelectable'] ? ($alc['messageUnseenCount'] ? "(" . $alc['messageUnseenCount'] . ")" : "") : ""), 
'total' => $alc['messageCount']); 
} 
$eaz = count($dvz); $ion = $dvz[$eaz - 1]['name']; 
for ($bi = $eaz - 1; $bi >= 0; $bi--) { 
$dvz[$bi]['display'] = (strpos($ion . "/", $dvz[$bi]['name'] . "/") !== false ? WME_CLOSED_SUBFOLDERS : WME_NO_SUBFOLDERS); 
if ($dvz[$bi]['type'] == KMS_FMAIL || $dvz[$bi]['type'] == KMS_FCONTACT) { 
$ion = $dvz[$bi]['name']; 
} 
elseif (in_array(substr(strstr($dvz[$bi]['name'], "/"), 1), $iom) && ($cwh[$bi]['type'] == KMS_FMAIL || $cwh[$bi]['type'] == KMS_FCONTACT)) { 
$dvz[$bi]['type'] = WME_NOT_ACCESSIBLE; 
} 
elseif (strpos($ion . "/", $dvz[$bi]['name'] . "/") === false) { 
$dvz[$bi]['nameLocal'] = "-1"; 
} 
else { 
$dvz[$bi]['type'] = WME_NOT_SELECTABLE; 
} 
} 
$bi = $eaz - 1; 
while ($bi > 1 && $cwh[$bi]['type'] != KMS_FMAIL && $cwh[$bi]['type'] != KMS_FCONTACT) { 
$dvz[$bi]['nameLocal'] = -1; 
$bi--; 
} 
$dvz[$bi]['display'] = WME_NO_SUBFOLDERS; 
$iar = ""; $ioo = 0; 
foreach ($dvz as $idb) { 
if ($idb['nameLocal'] == "") { 
$iop = explode("/", $idb['name']); 
$iop[0] = ""; 
$eaz = count($iop); 
if ($iop[1] == FLD_PUBLIC && $iop[2] != "" || $iop[1] == FLD_TRASH && $iop[2] == FLD_CONTACT) { 
$iop[1] = dhb($iop[1]); 
$iop[2] = dhb($iop[2]); 
$wl = 3; 
} 
else { 
$wl = min($eaz - 1, (substr($iop[1], 0, 1) != "~" ? 1 : 2)); 
$iop[$wl] = dhb($iop[$wl]); 
$wl++; 
} 
for ($bi = $wl; $bi < $eaz; $bi++) $iop[$bi] = kerio_convert("utf-7m", "utf-8", $iop[$bi]); 
$idb['nameLast'] = aiz($iop[$eaz - 1]); 
$idb['shortLast'] = aiz(iio($iop[$eaz - 1], FLD_OUTPUT_LENGTH)); 
if ($_SESSION['pda'] == 0) { 
$iae = substr(implode(" : ", $iop), 3); 
if ($idb['subList'] > 0) { 
$hz0 = mb_strlen($iae); 
if ($hz0 > 2 * 20 + 3) { 
$hz0 = ceil(2 * 20 / ($eaz - 1)); 
for ($bi = 1; $bi < $eaz; $bi++) if (mb_strlen($iop[$bi]) > $hz0) $iop[$bi] = mb_substr($iop[$bi], 0, $hz0) . "..."; 
$iae = substr(implode(" : ", $iop), 3); 
} 
} 
$idb['nameLocal'] = aiz($iae, ENT_QUOTES); 
} 
else { 
$hz0 = (strpos($iop[$eaz - 1], "<kerio:text") !== false ? -1 : mb_strlen($iop[$eaz - 1])); 
if ($hz0 > 15) { 
$iop[$eaz - 1] = mb_substr($iop[$eaz - 1], 0, 12) . "..."; 
} 
$ark = ""; 
for ($bi = 2; $bi < $eaz; $bi++) $ark .= "- "; 
$idb['nameLocal'] = $ark . aiz($iop[$eaz - 1]); 
} 
$iar[($idb['name'] == $_SESSION['fld'] ? WME_CURRENT_FOLDER : $ioo++)] = $idb; 
} 
} 
if ($_SESSION['pda'] == 0) { 
$ioq = array(); 
foreach ($iar as $idb) { 
$fb = $idb['name']; 
$ior = $idb['nameLocal']; 
$ioq[$fb] = $ior; 
$imn = explode("/", $fb); 
$ios = explode(" : ", $ior); 
$eaz = count($imn); 
$iot = $imn[0]; 
$iou = $ios[0]; 
for ($bi = 1; $bi < $eaz; $bi++) { 
$iot .= "/" . $imn[$bi]; 
if (mb_strlen($ioq[$iot]) > mb_strlen($iou)) $ioq[$iot] = $iou; 
$iou .= " : " . $ios[$bi]; 
} 
} 
foreach ($iar as $cie => $idb) { 
if ($iar[$cie]['subList'] > 0) { 
$eb0 = mb_substr($iar[$cie]['name'], 0, strrpos($iar[$cie]['name'], "/")); 
$iar[$cie]['nameLocal'] = $ioq[$eb0] . " : " . $iar[$cie]['shortLast']; 
} 
elseif ($iar[$cie]['subList'] == 0) { 
$iar[$cie]['nameLocal'] = $iar[$cie]['shortLast']; 
} 
} 
} 
foreach ($iar as $cie => $idb) { 
foreach (array('nameLocal', 'nameLast', 'shortLast') as $gvs) { 
$iar[$cie][$gvs] = str_replace("  ", " &nbsp;", $iar[$cie][$gvs]); 
} 
} 
return $iar; 
} 
function iau($iar, $anz) { 
if (!is_array($iar)) return ""; 
$bi = 0; 
$dvz = array(); 
foreach ($iar as $idb) { 
$cie = ($idb['name'] != $anz ? $bi++ : WME_CURRENT_FOLDER); 
$dvz[$cie] = $idb; 
} 
return $dvz; 
} 
function ian($l, $iov, $ibr, $dz0 = "") { 
$o = $l->getMyUserInfo(); 
$aa = $o->getSettings(); 
$iow = explode("|", $aa['toggledFld']); 
switch ($iov) { 
case WME_RENAME_FOLDER: 
$iae = array(); 
if (is_array($iow)) foreach ($iow as $iox) { 
$iae[] = str_replace($ibr, $dz0, $iox); 
} 
$iow = $iae; 
break; 
case WME_PACK_FOLDER: 
$iae = array(); 
if (is_array($iow)) foreach ($iow as $iox) { 
if ($iox != $ibr) $iae[] = $iox; 
} 
$iow = $iae; 
break; 
case WME_UNPACK_FOLDER: 
if (array_search($ibr, $iow) === false) $iow[] = $ibr; 
break; 
case WME_UNPACK_ALL_FOLDERS: 
$iae = explode("/", $ibr); 
$eaz = count($iae); 
$cwj = $iae[0]; 
for ($bi = 1; $bi < $eaz; $bi++) { 
$cwj .= "/" . $iae[$bi]; 
if (array_search($cwj, $iow) === false) $iow[] = $cwj; 
} 
break; 
} 
$aa['toggledFld'] = implode("|", $iow); 
if (!$o->saveSettings($aa)) iec(1431); 
} 
function igz($l, $iar) { 
$o = $l->getMyUserInfo(); 
$aa = $o->getSettings(); 
$p = $o->getUserName(); 
switch ($iar[WME_CURRENT_FOLDER]['type']) { 
case KMS_FMAIL: $ctf = "browse.php"; break; 
case KMS_FCONTACT: $ctf = "contact.php"; break; 
default: $ctf = ""; break; 
} 
?>
<table cellspacing='0' cellpadding='2' border='0' xwidth='100%' class='menuTable'>
<tr class='head'>
<td nowrap align='left'>
<kerio:text id='main-folders'/>
<span class='bracket'>[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span>
</td>
</tr>
<tr class='tree'>
<td nowrap class='topMargin'>
<img src='/default/gfx/user.gif' width='16' height='16' alt='*' title=''>
<a href='quota.php'>
<?php
print 
($_SESSION['fld'] !== "" ? "" : "<b class='actFolder'>") . 
(mb_strlen($p) > USERNAME_LENGTH + 3 ? mb_substr($p, 0, USERNAME_LENGTH) . "..." : $p) . 
($_SESSION['fld'] !== "" ? "" : "</b>") 
?>
</a>&nbsp;
</td>
</tr>
<tr class='tree'>
<td valign='top' nowrap>
<ul class='firstUl'>
<?php
$ioy = 0; 
$dtp = ""; 
$ioz = 0; 
$iow = explode("|", $aa['toggledFld']); 
foreach ($iar as $cie => $idb) { 
if ($idb['subList'] == 0 || ($idb['subList'] <= $ioz && array_search(substr($idb['name'], 0, strrpos($idb['name'], "/")), $iow) !== false)) { 
$ioz = $idb['subList'] + 1; 
for ($avg = $ioy; $avg < $idb['subList']; $avg++) { 
$dtp .= "<ul>"; 
} 
for ($avg = $idb['subList']; $avg < $ioy; $avg++) { 
$dtp .= "</ul>"; 
} 
$ioy = $idb['subList']; 
if ($cie === WME_CURRENT_FOLDER) { 
$ifl = "<b class='actFolder'>"; $ifm = "</b>"; 
} 
else { 
$ifl = $ifm = ""; 
} 
$dtp .= "<li>"; 
if ($idb['display'] != WME_NO_SUBFOLDERS && array_search($idb['name'], $iow) !== false) $idb['display'] = WME_OPENED_SUBFOLDERS; 
switch ($idb['display']) { 
case WME_CLOSED_SUBFOLDERS: 
$dtp .= "<a href='" . $ctf . "?actionn=folderMinus&dc=" . $_SESSION['dc'] . "&pmFld=" . urlencode($idb['name']) . "'><img src='/default/gfx/plus.gif' width='16' height='16' border='0' alt='+' title=''></a>"; 
$ip0 = $idb['subList']; 
break; 
case WME_OPENED_SUBFOLDERS: 
$dtp .= "<a href='" . $ctf . "?actionn=folderPlus&dc=" . $_SESSION['dc'] . "&pmFld=" . urlencode($idb['name']) . "'><img src='/default/gfx/minus.gif' width='16' height='16' border='0' alt='-' title=''></a>"; 
break; 
case WME_NO_SUBFOLDERS: 
$dtp .= "<img src='gfx/trpix.gif' width='16' height='16'>"; 
$ip0 = $idb['subList']; 
break; 
} 
switch ($idb['type']) { 
case KMS_FMAIL: 
$ipa = (strstr($idb['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($idb['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail")); 
$ipb = false; 
$ipc = true; 
$ipd = "browse.php?actionn=browseSearchOff&dc=" . $_SESSION['dc'] . "&"; 
break; 
case KMS_FCONTACT: 
$ipa = "fcontact"; 
$ipb = false; 
$ipc = true; 
$ipd = "contact.php?actionn=contactSearchOff&dc=" . $_SESSION['dc'] . "&"; 
break; 
case WME_NOT_ACCESSIBLE: 
$ipa = "folder_gray"; 
$ipc = false; 
break; 
default: 
$ipa = "folder"; 
$ipb = true; 
$ipc = ($idb['type'] != WME_NOT_SELECTABLE && ($idb['rights'] == "A" || $idb['rights'] == "S")); 
$ipd = "browse.php?"; 
break; 
} 
$anz = ($idb['shortLast'] == $idb['nameLast'] ? $idb['nameLast'] : "<span title='" . $idb['nameLast'] . "'>" . $idb['shortLast'] . "</span>"); 
$dtp .= 
($ipc ? "<a href='" . $ipd . "fld=" . urlencode($idb['name']) . ($ipb ? "" : "&pag=0") . "'>" : "") . 
"<img src='/default/gfx/" . $ipa . ($idb['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' border='0'>&nbsp;" . 
$ifl . $anz . "&nbsp;". $idb['unseen'] . $ifm . 
($ipc ? "</a>" : "") . "</li>\n"; 
} 
} 
for ($bi = 0; $bi < $ip0; $bi++) $dtp .= "</ul>"; 
print $dtp; 
?>
</ul>
</td>
</tr>
</table>
<?php
} 
function iha($l, $iar) { 
switch ($iar[WME_CURRENT_FOLDER]['type']) { 
case KMS_FMAIL: $ctf = "browse.php"; $ipe = 'browseGo'; break; 
case KMS_FCONTACT: $ctf = "contact.php"; $ipe = 'contactGo';break; 
default: return; 
} 
$o = $l->getMyUserInfo(); 
$p = $o->getUserName(); 
$ijv = ($_SESSION['pda'] == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH); 
$dtp = 
"<table cellpadding='0' cellspacing='2' border='0'>" . 
"<tr><td nowrap>" . 
"<input type='hidden' name='adm' value='0'>" . 
"<select name='fld' id='fldCombox'>" . 
"<option value='root'>" . 
(mb_strlen($p) > $ijv + 3 ? mb_substr($p, 0, $ijv) . "..." : $p) . 
"</option>"; 
foreach ($iar as $cie => $idb) { 
if ($idb['type'] != KMS_FMAIL && $idb['type'] != KMS_FCONTACT) continue; 
$dtp .= 
"<option " . ($cie === WME_CURRENT_FOLDER ? "selected " : "") . 
"value='" . ($idb['type'] != $iar[WME_CURRENT_FOLDER]['type'] ? "!" : "") . aiz($idb['name']) . "'>" . $idb['nameLocal'] . ($idb['unseen'] != "" ? " " : "") . $idb['unseen'] . 
"</option>"; 
} 
print $dtp . 
"</select>&nbsp;". 
"<input id='goButton' type='submit' name='" . $ipe . "' value='<kerio:text id='express-go'/>'>" . 
($_SESSION['fld'] !== "" && $_SESSION['pda'] == 0 ? 
"<td><span class='bracket'>&nbsp;[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span></td>" : "") . 
"</td></tr></table>"; 
} 
function ibi($iar) { 
$dtp = " <span id='newFld'><select name='newFld'>"; 
foreach ($iar as $idb) { 
if ($idb['type'] != $iar[WME_CURRENT_FOLDER]['type']) continue; 
if ($idb['rights'] == "R") continue; 
$dtp .= "<option" . ($_SESSION['prevFolder'][$idb['type']] == $idb['name'] ? " selected" : "") . " value='" . aiz($idb['name']) . "'>" . $idb['nameLocal'] . "</option>"; 
} 
print $dtp; 
$m = ($iar[WME_CURRENT_FOLDER]['rights'] != "R" ? "detailMove" : "detailCopy"); 
?>
</select>
</span><input id='ok' name='<?php print $m?>' type='submit' value='<kerio:text id='common-ok'/>'>
</td>
</tr>
</table><?php
} 
function idv($l, $iar) { 
$o = $l->getMyUserInfo(); 
$akw = $l->getFolderStore(); 
$iom = $akw->getSharedFolderMappings(); 
$ion = $chb = ""; 
foreach ($iom as $dxw) { 
if (($iae = substr($dxw, 0, strpos($dxw, "/"))) != $ion) $chb['users'][] = $iom[] = $ion = $iae; 
} 
foreach ($iar as $idb) { 
$chb[$idb['name']] = (in_array(substr(strstr($idb['name'], "/"), 1), $iom) ? WME_SUBSCRIBED_FOLDER : WME_MY_FOLDER); 
} 
return $chb; 
} 
function idw($l, $iar, $chb) { 
$o = $l->getMyUserInfo(); 
$p = $o->getUserName(); 
$ipf = ($_SESSION['pda'] == 0 ? "&nbsp;" : ""); 
?>
<table cellspacing='0' cellpadding='2' border='1' width='100%' class='folderTable' id='folderTable'>
<?php if ($_SESSION['pda'] == 0) :?>
<tr class='head'>
<td width='60%'><kerio:text id='common-folder'/></td>
<td width='1%'><kerio:text id='contact-list-items'/></td>
<td width='1%'><kerio:text id='express-action'/></td>
<td><kerio:text id='express-sharing'/></td>
</tr>
<tr>
<td nowrap><img src='../default/gfx/user.gif' width='16' height='16' alt='*' title=''> <a href='quota.php' class='folder'>
<?php
print (mb_strlen($p) > USERNAME_LENGTH + 3 ? "<span title='" . aiz($p) . "'>" . mb_substr($p, 0, USERNAME_LENGTH) . "...</span>" : $p); 
?>
</a></td>
<td align='right'>&nbsp;</td>
<td><a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a></td>
<td nowrap><a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/></a></td>
</tr>
<?php else: ?>
<tr>
<td width='1%'><img src='../default/gfx/user.gif' width='16' height='16' alt='*' title=''></td>
<td>
<a href='quota.php' class='folder'>
<?php
print (mb_strlen($p) > PDA_USERNAME_LENGTH + 3 ? mb_substr($p, 0, PDA_USERNAME_LENGTH) . "..." : $p); 
?>
</a><br>
<a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a> - <a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/>
</td>
</tr>
<?php endif; ?>
<?php
$dtp = ""; 
$ipg = ($_SESSION['pda'] == 0 ? 2 : 1); 
foreach ($iar as $cie => $idb) { 
$bdt = ""; 
if ($idb['type'] != WME_NOT_SELECTABLE && $idb['type'] != WME_NOT_ACCESSIBLE) { 
switch ($idb['type']) { 
case KMS_FMAIL: 
$ipa = (strstr($idb['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($idb['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail")); 
break; 
case KMS_FCONTACT: 
$ipa = "fcontact"; 
break; 
default: 
$ipa = "folder"; 
break; 
} 
if ($idb['rights'] == "A" || $idb['rights'] == "S") { 
$m = "<a href='folder.php?goto=folderCreate&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-new-subfolder'/></a>"; 
if (!dzd($idb['name'], $chb[$idb['name']])) { 
$m .= 
" - <a href='folder.php?goto=folderRename&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-rename'/></a>" . 
" - <a href='folder.php?goto=folderMove&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-move'/></a>" . 
" - <a href='folder.php?goto=folderDelete&dc=" . $_SESSION['dc'] . "&fld=" . urlencode($idb['name']) . "&fldType=" . $idb['type'] . "' name='del'><kerio:text id='express-delete'/></a>"; 
} 
$iph = ($chb[$idb['name']] ? "<a href='folder.php?goto=folderUnsubscribe&dc=" . $_SESSION['dc'] . "&fld=" . urlencode($idb['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : ""); 
$iph .= "<a href='folder.php?goto=folderSharing&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-access-rights'/></a>"; 
} 
else { 
$m = $ipf; 
$iph = ($chb[$idb['name']] ? "<a href='folder.php?goto=folderUnsubscribe&dc=" . $_SESSION['dc'] . "&fld=" . urlencode($idb['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : ""); 
$iph .= (strpos(strstr($idb['name'], "/"), "/" . FLD_PUBLIC) !== false || 1? 
"<a href='folder.php?goto=folderSharing&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-access-rights'/></a>" : 
$ipf); 
} 
$bdt = "row" . $ipg; 
} 
else { 
$ipa = ($idb['type'] == WME_NOT_SELECTABLE ? "folder" : "folder_gray"); 
$m = ($idb['rights'] == "A" && ($idb['name'] == "~" . $p . "/" . FLD_PUBLIC || $idb['name'] == "~" . $p . "/" . FLD_ARCHIVE) ? 
"<a href='folder.php?goto=folderCreate&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-new-subfolder'/></a>" : 
$ipf); 
if ($chb[$idb['name']]) { 
$bdt = "row" . $ipg; 
$iph = "<a href='folder.php?goto=folderUnsubscribe&dc=" . $_SESSION['dc'] . "&fld=" . urlencode($idb['name']) . 
($idb['type'] == WME_NOT_SELECTABLE ? "&all=1' name='unsub'" : "' name='unsub2'") . 
"><kerio:text id='express-unsubscribe'/></a>"; 
} 
else { 
$iph = (1 && ($idb['name'] == "~" . $p . "/" . FLD_PUBLIC || $idb['name'] == "~" . $p . "/" . FLD_ARCHIVE) ? 
"<a href='folder.php?goto=folderSharing&fld=" . urlencode($idb['name']) . "'><kerio:text id='express-access-rights'/></a>" : 
$ipf); 
} 
} 
if ($cie === WME_CURRENT_FOLDER) { 
$ifl = "<b class='actFolder'>"; $ifm = "</b>"; 
} 
else { 
$ifl = $ifm = ""; 
} 
$bsf = ($_SESSION['pda'] == 1 || $idb['shortLast'] == $idb['nameLast'] ? "" : " title='" . $idb['nameLast'] . "'"); 
switch ($idb['type']) { 
case KMS_FMAIL: 
$ipi = "<a" . $bsf . " href='browse.php?fld=" . urlencode($idb['name']) . "' class='folder'" . ($bdt ? " id='" . $bdt . "'" : "") . ">"; $ipj = "</a>"; 
break; 
case KMS_FCONTACT: 
$ipi = "<a" . $bsf . " href='contact.php?fld=" . urlencode($idb['name']) . "' class='folder'" . ($bdt ? " id='" . $bdt . "'" : "") . ">"; $ipj = "</a>"; 
break; 
default: 
if ($bdt == "") { 
if ($bsf == "") { 
$ipi = ""; 
$ipj = ""; 
} 
else { 
$ipi = "<span" . $bsf . ">"; 
$ipj = "</span>"; 
} 
} 
else { 
$ipi = "<span" . $bsf . " id='" . $bdt . "'>"; $ipj = "</span>"; 
} 
break; 
} 
if ($_SESSION['pda'] == 0) { 
$dtp .= 
"<tr>" . 
"<td nowrap>" . 
"<img src='gfx/trpix.gif' width='" . ($idb['subList'] * 16 + 16) . "' height='16'>" . 
"<img src='../default/gfx/" . $ipa . ($idb['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''> " . $ifl . 
$ipi . $idb['shortLast'] . $ipj . $ifm . 
"</td>". 
"<td align='right'>" . (substr($idb['nameLast'], 0, 1) == "~" || $idb['type'] == WME_NOT_SELECTABLE || $idb['type'] == WME_NOT_ACCESSIBLE ? "&nbsp;" : $idb['total']) . "</td>" . 
"<td nowrap>" . $m . "</td>" . 
"<td nowrap>" . $iph . "</td>" . 
"</tr>"; 
} 
else { 
$dtp .= 
"<tr>" . 
"<td>" . "<img src='../default/gfx/" . $ipa . ($idb['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''>" . "</td>" . 
"<td>" . $ifl . $ipi . $idb['nameLocal'] . $ipj . $ifm . "<br>" . $m . ($m != $ipf && $iph != $ipf ? " - " : "") . $iph . 
"</td>" . 
"</tr>"; 
} 
$ipg++; 
} 
print $dtp; ?>
</table><?php
} 
function idx($l, $ifo, $ipk) { 
if ($ipk) { 
$dtp = "<kerio:text id='fld-new'/>"; 
$o = $l->getMyUserInfo(); 
$ioe = "~" . $o->getUserName(); 
} 
else { 
$dtp = "<kerio:text id='express-create-folder'/> \"" . $ifo['nameLast'] . "\""; 
$ioe = aiz($ifo['name']); 
} 
?>
<br><h4 class='h4_small'><?php print $dtp ?></h4><br>
<input type='hidden' name='actionn' value='folderCreate'>
<input type='hidden' name='srcFld'  value='<?php print $ioe ?>'>
<table cellspacing='0' cellpadding='2' border='0'>
<?php if ($_SESSION['pda'] == 0): ?>
<tr>
<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>
<td nowrap><kerio:text id='fld-new-type'/>:</td>
<td colspan='99' width='100%'>
<select name='fldType'>
<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>
<option value='<?php print KMS_FCONTACT . "'" . ($ifo['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>


			</select>


		</td>


	</tr>





	<?php else: ?>





	<tr>


		<td nowrap><kerio:text id='fld-new-name'/>:</td><td width='100%'><input type='text' name='newFld' xclass='full'></td>


	</tr>


	<tr>


		<td nowrap><kerio:text id='fld-new-type'/>:</td>


		<td width='100%'>


			<select name='fldType'>


				<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>


				<option value='<?php print KMS_FCONTACT . "'" . ($ifo['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>


			</select>


		</td>


	</tr>





	<?php endif; ?>





	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function idy($ifo) { 
 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-rename-folder'/> "<?php print $ifo['nameLast']?>"</h4><br>





	<input type='hidden' name='actionn' value='folderRename'>


	<input type='hidden' name='srcFld'  value='<?php print aiz($ifo['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>


	</tr>


	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function idz($l, $iar) { 
 
 $ipl = $iar[WME_CURRENT_FOLDER]['name']; 
 $ipm = substr($ipl, 0, strrpos($ipl, "/")); 
 $dtp = ""; 
 
 foreach ($iar as $cie => $idb) { 
 if ($cie === WME_CURRENT_FOLDER) continue; 
 if ($idb['rights'] == "R" || $idb['rights'] == "E") continue; 
 if ($idb['name'] == $ipm || strpos($idb['name'] . "/", $ipl . "/") === 0) continue; 
 
 $dtp .= "<option value='" . aiz($idb['name']) . "'>" . $idb['nameLocal'] . "</option>"; 
 } 
 
 
 if ($iar[WME_CURRENT_FOLDER]['subList'] != 0) { 
 
 $ijv = ($_SESSION['pda'] == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH); 
 
 $o = $l->getMyUserInfo(); 
 $p = $o->getUserName(); 
 $dtp = 
 "<option value='~" . $p . "'>" . 
 (mb_strlen($p) > $ijv + 3 ? mb_substr($p, 0, $ijv) . "..." : $p) . 
 "</option>" . $dtp; 
 } 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-move-folder'/> "<?php print $iar[WME_CURRENT_FOLDER]['nameLast']?>"</h4><br>





	<input type='hidden' name='actionn' value='folderMove'>


	<input type='hidden' name='srcFld'  value='<?php print aiz($iar[WME_CURRENT_FOLDER]['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td nowrap><kerio:text id='express-target-folder'/>:</td><td><select name='newFld'><?php print $dtp?></select></td>


	</tr>


	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 $e0f = array( 
 LEVEL_ADMIN => "lrswicda", 
 LEVEL_EDITOR => "lrswid", 
 LEVEL_READER => "lr" 
 ); 
 
 $e0e = array( 
 LEVEL_ADMIN => "<kerio:text id='fld-sharing-administrator'/>", 
 LEVEL_EDITOR => "<kerio:text id='fld-sharing-editor'/>", 
 LEVEL_READER => "<kerio:text id='fld-sharing-reader'/>" 
 ); 
 
 
 
 function e0g($dwl) { 
 foreach ($GLOBALS['e0f'] as $e0h => $dzy) { 
 $e0i = true; 
 for ($bi = 0; $bi < strlen($dzy); $bi++) { 
 if (!strstr($dwl, $dzy[$bi])) { 
 $e0i = false; 
 } 
 } 
 if ($e0i) return $e0h; 
 } 
 } 
 
 
 
 
 function ie0($l, $ifo) { 
 
 $akw = $l->getFolderStore(); 
 $cri = $akw->getFolderAcl($ifo['name'], &$iae); 
 
 $o = $l->getMyUserInfo(); 
 $p = strtolower($o->getUserName()); 
 
 
 $ipn = (strpos($akw->getFolderAclMyrights($ifo['name']), "a") !== false); 
 
 $bi = 0; $dvp = 0; 
 foreach ($iae as $crr) { 
 $iae[$bi]['rights'] = $GLOBALS['e0e'][e0g($crr['rights'])]; 
 
 
 if (strtolower($crr['name']) == $p && strpos($crr['rights'], "O") !== false) { 
 $iae[$bi]['rights'] = ""; 
 $dvp--; 
 } 
 elseif (strpos($crr['rights'], "a") !== false) { 
 
 
 if ($ifo['name'] == "~" . $p . "/" . FLD_PUBLIC || $ifo['name'] == "~" . $p . "/" . FLD_ARCHIVE) { 
 $dvp--; 
 } 
 } 
 $bi++; 
 } 
 $dvp += $bi; 
 
 
 $bi = 0; 
 foreach ($iae as $iox) { 
 
 
 if (substr($iox['name'], 0, 1) == "[") { 
 $iae[$bi]['icon'] = "<img src='/default/gfx/usersg.gif' width='16' height='16' alt='G' title=''>"; 
 $iae[$bi]['display'] = aiz(substr($iox['name'], 1, strlen($iox['name']) - 2)); 
 } 
 
 
 elseif (substr($iox['name'], 0, 9) == 'authuser@') { 
 $iae[$bi]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>"; 
 $iae[$bi]['display'] = '<kerio:text id="fld-sharing-domain-from"/> '. aiz(substr($iox['name'], 9)); 
 } 
 
 elseif ($iox['name'] == 'authuser') { 
 $iae[$bi]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>"; 
 $iae[$bi]['display'] = '<kerio:text id="fld-sharing-all"/>'; 
 } 
 
 elseif ($iox['name'] == 'anyone') { 
 $iae[$bi]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>"; 
 $iae[$bi]['display'] = '<kerio:text id="fld-sharing-anonymous"/>'; 
 } 
 
 
 else { 
 $iae[$bi]['icon'] = "<img src='/default/gfx/userg.gif' width='16' height='16' alt=''>"; 
 $iae[$bi]['display'] = aiz($iox['name']); 
 } 
 $bi++; 
 } 
 ?>





	<script type="text/javascript" src="funcFolder.js?v=<?php print SERVER_HASH?>"></script>


	<br><h4 class='h4_small'><kerio:text id='express-sharing-table'/> "<?php print $ifo['nameLast']?>"</h4><br>





	<?php

 if (!$ipn) { 
 foreach ($iae as $iox) { 
 if ($iox['rights'] == "") continue; 
 $dtp .= "&nbsp;" . $iox['icon'] . "&nbsp;" . $iox['display'] . " (" . $iox['rights'] . ")<br>"; 
 } 
 print $dtp . "<br><input type='submit' name='cancel' value='<kerio:text id='common-back'/>'>"; 
 return; 
 } 
 
 $ipo = ($dvp > 0 ? "radio" : "hidden"); 
 ?>





	<input type='hidden' name='fld' value='<?php print aiz($ifo['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>





	<?php if ($_SESSION['pda'] == 0) :?>





	<tr>


		<td width='21'><input type='<?php print $ipo ?>' name='actionn' value='sharingAdd' id='add' checked></td>


		<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>


		<td>


			<select name='userGroup'>


				<option value='U'><kerio:text id='fld-sharing-user'/></option>


				<option value='G'><kerio:text id='fld-sharing-group'/></option>


				<option value='D'><kerio:text id='fld-sharing-domain'/></option>


				<option value='A'><kerio:text id='fld-sharing-all'/></option>


				<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>


			</select>


			<input type='text' name='user1' size='15'>


		</td>


		<td>


			<kerio:text id='express-sharing-rights'/>


		</td>


		<td>


			<select name='rights'>


				<option value='A'><kerio:text id='fld-sharing-administrator'/></option>


				<option value='E'><kerio:text id='fld-sharing-editor'/></option>


				<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>


			</select>


		</td>


	</tr>





	<? else: ?>





	<tr>


		<td width='21'><input type='<?php print $ipo ?>' name='actionn' value='sharingAdd' id='add' checked></td>


		<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<select name='userGroup'>


				<option value='U'><kerio:text id='fld-sharing-user'/></option>


				<option value='G'><kerio:text id='fld-sharing-group'/></option>


				<option value='D'><kerio:text id='fld-sharing-domain'/></option>


				<option value='A'><kerio:text id='fld-sharing-all'/></option>


				<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>


			</select>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<input type='text' name='user1' size='15'>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<kerio:text id='express-sharing-rights'/>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<select name='rights'>


				<option value='A'><kerio:text id='fld-sharing-administrator'/></option>


				<option value='E'><kerio:text id='fld-sharing-editor'/></option>


				<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>


			</select>


		</td>


	</tr>








	<? endif; ?>





	<?php if ($dvp > 0): ?>





	<tr>


		<td><input type='radio' name='actionn' value='sharingRemove' id='remove'></td>


		<td nowrap colspan='4'><label for='remove'><kerio:text id='express-sharing-remove'/></label></td>


	</tr>





	<?php

 $dtp = ""; $bi = 1; 
 
 foreach ($iae as $iox) { 
 if ($iox['rights'] == "") continue; 
 $dtp .= 
 '<tr><td>&nbsp;</td><td colspan="4"><input ' . 
 'type="checkbox" name="user2[]" value="' . aiz($iox['name']) . '" id="x' . $bi . '">' . 
 '<label for="x' . $bi . '">&nbsp;' . $iox['icon'] . '&nbsp;' . $iox['display'] . ' (' . $iox['rights'] . ')</label>' . 
 '</td></tr>'; 
 $bi++; 
 } 
 print $dtp; 
 ?>





	<?php endif; ?>





	</table>


	<br>


	<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><p>


	<?php

 } 
 
 
 
 
 function iea() { 
 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-sharing-subscribe'/>:</h4><br>





	<input type='hidden' name='actionn' value='folderSubscribe'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td><input type='text' name='user' size='15'></td>


	</tr>


	</table>


	<br>


	<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function ieb($m, $ifo) { 
 
 switch ($m) { 
 case "folderDelete": 
 $fy = "<kerio:text id='fld-really-delete'/>"; 
 $fb = $ifo['nameLast']; 
 break; 
 
 case "folderUnsubscribeAll": 
 $fy = "<kerio:text id='express-sharing-unsubscribe'/>"; 
 $fb = substr($ifo['nameLast'], 1); 
 
 print "<input type='hidden' name='all' value='1'>"; 
 $m = "folderUnsubscribe"; 
 break; 
 
 case "folderUnsubscribe": 
 $fy = "<kerio:text id='fld-really-disconnect'/>"; 
 $fb = $ifo['nameLast']; 
 break; 
 } 
 
 print "<br><h4>" . $fy . " \"" . $fb . "\"?</h4><br>"; 
 ?>





	<input type='hidden' name='actionn' value='<?php print $m?>'>


	<input type='submit' value='<kerio:text id='common-yes'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-no'/>'>


	<?php

 } 
 ?>