<?php
define('irl', 'Unknown'); 
define('irm', 'Unknown'); 
define('irn', '0'); 
define('iro', 312); 
define('irp', 399); 
define('irq', 412); 
define('irr', 419); 
define('irs', 420); 
define('irt', 599); 
class iru { 
private $irv = array ( 
'MSIE' => array('major' => 6, 'minor' => 0), 
'Firefox' => array('major' => 1, 'minor' => 5), 
'Safari' => array('major' => 1, 'minor' => 3) 
); 
public function __construct($irv = Array()) { 
if (is_array($irv) && !empty($irv)) { 
$this->irv = $irv; 
} 
$irw = $_SERVER['HTTP_USER_AGENT']; 
$irx['platform'] = irl; 
$irx['browser'] = irm; 
$irx['version']['major'] = irn; 
$irx['version']['minor'] = irn; 
if (stripos($irw, 'win')) { 
$irx['platform'] = 'Windows'; 
} elseif (stripos($irw, 'mac')) { 
$irx['platform'] = 'MacIntosh'; 
} elseif (stripos($irw, 'linux')) { 
$irx['platform'] = 'Linux'; 
} 
if ((FALSE !== stripos($irw, 'msie')) && (FALSE === stripos($irw, 'opera'))) { 
$irx['browser'] = 'MSIE'; 
$iry = explode(' ', stristr( $irw, 'msie')); 
$irz = $iry[1]; 
$is0 = strpos($irz, '.'); 
$irx['version']['major'] = (int) substr($irz, 0, $is0); 
$irx['version']['minor'] = (int) substr($irz, $is0+1, strpos($irz, '.', $is0)); 
$irx['style'] = ' ie ie' . $irx['version']['major'] . $irx['version']['minor']; 
} elseif (FALSE !== stripos($irw, 'firefox')) { 
$irx['browser'] = 'Firefox'; 
$iry = stristr($irw, 'firefox'); 
$iry = explode('/', $iry); 
$irz = $iry[1]; 
$is0 = strpos($irz, '.'); 
$irx['version']['major'] = (int) substr($irz, 0, $is0); 
$irx['version']['minor'] = (int) substr($irz, $is0+1, strpos($irz, '.', $is0)); 
$irx['style'] = ' ff ff' . $irx['version']['major'] . $irx['version']['minor']; 
} elseif ((FALSE !== stripos($irw, 'safari')) && (FALSE === stripos($irw, 'omniweb'))) { 
$irx['browser'] = 'Safari'; 
$iry = explode(' ', stristr( strtolower($irw), 'applewebkit/')); 
$isa = (int) str_replace( 'applewebkit/', '', $iry[0]); 
if (iro > $isa) { 
$irx['version']['major'] = 1; 
$irx['version']['minor'] = 2; 
} elseif (irq > $isa) { 
$irx['version']['major'] = 1; 
$irx['version']['minor'] = 3; 
} elseif (irs > $isa) { 
$irx['version']['major'] = 2; 
$irx['version']['minor'] = 0; 
} else { 
$irx['version']['major'] = 3; 
$irx['version']['minor'] = 0; 
} 
$irx['style'] = ' sf sf' . $irx['version']['major'] . $irx['version']['minor']; 
} 
$this->irx = $irx; 
} 
public function isb() { 
if (($this->irx['platform'] != irl) && 
($this->irx['browser'] != irl)) { 
$isc = $this->irx['browser']; 
$isd = $this->irv; 
if ($isd[$isc]['major'] > $this->irx['version']['major']) { 
return FALSE; 
} 
if ($isd[$isc]['major'] < $this->irx['version']['major']) { 
return TRUE; 
} 
if ($isd[$isc]['minor'] <= $this->irx['version']['minor']) { 
return TRUE; 
} 
} 
return FALSE; 
} 
public function ise() { 
if ($this->isb()) { 
return $this->irx['style']; 
} 
return ''; 
} 
} 
?>